#define Hg_Deposition
#define Hg_Photo_Chem
#define Hg_Photo_Red_2P
#define Hg_Photo_DeMeth
#define Hg_Photo_Ox
#define Hg_Photo_Chem_Lat
#define Hg_Sinking
c#define Hg_Sinking_Implicit
#define Hg_Subsurface_Speciation
#define Hg_Fractionation

c#define Hg_Particles_Fractionation

c#define Hg_Dark_Fractionation
c#define Hg_Dark_2P_0_Fractionation
c#define Hg_Dark_2P_MM_Fractionation
c#define Hg_Dark_MM_0_Fractionation

c#define Hg_Photo_Fractionation
c#define Hg_Photo_2P_0_Fractionation
c#define Hg_Photo_MM_0_Fractionation

c#define Hg_Degas_Fractionation
c#define Hg_Degas_0_Fractionation
c#define Hg_Degas_DM_Fractionation

#define Hg_MIF_Fractionation
#define Hg_MIF_MM_0
c#define Hg_MIF_2P_0


#define Hg_Mass_Dep_202_199 3.96d0
#define Hg_2P_Atm_Dep_Rate 2.d-13  /* mol/l yr surface layer global average */


#define Hg_2P_Binding_Constant 3.d4  /* 2.d6 */ /* from Zhang */
#define Hg_2P_Binding_MDF -3.5d0
#define POC_Sinking_Rate 0.5  /* meters per year */ 
#define Hg_Sinking_Rate 20.d0
c     from 3 mol C / m2 year export prod, and surface POC of 0.5 mol/m3

#define Hg_2Plus_Meth_Oxygen_Critical 50.d-6

      subroutine hg_cycle

c      implicit none

      INCLUDE 'parameter.include'
      INCLUDE 'equivalence.include'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.chemis'
      include 'common.divers'
      INCLUDE 'common.production'
      include 'common.wathic'
      include 'common.topogr'
      include 'common.biocon'
      include 'common.hg'

#define i0  1
#define iDM 2
#define iMM 3
#define i2P 4

      real rate_subsurface(4,4), rate_surface(4,4),
     $     mdf_alpha_subsurface(4,4), mdf_alpha_surface(4,4),
     $     mif_alpha_subsurface(4,4), mif_alpha_surface(4,4), 
     $     epsilon_199_subsurface(4,4), epsilon_202_subsurface(4,4),
     $     epsilon_199_surface(4,4), epsilon_202_surface(4,4),
     $     rate_199_subsurface(4,4), rate_199_surface(4,4),
     $     rate_202_subsurface(4,4), rate_202_surface(4,4),
     $     degas_rate(4), degas_199_rate(4),
     $     degas_202_rate(4)

      real a(4,4),b(4)

      poc_inv = 0.d0
      poc_profile = 0.d0
      poc_profile_n = 0
      hg_particle_src = 0.d0
      hg_deposition = 0.d0
      hg_0_degassing = 0.d0
      hg_dm_degassing = 0.d0
c     surface poc inventory
      DO j=jl1,jle
         DO i=1,ie
            if(prorca(i,j) .GT. 0.d0) then
               poc_inv(i,j,1) = prorca(i,j)  ! mol/m3 timestep
     $              * ddz(i,j,1) / 1.d2     ! mol/m2 timestep   
     $              / POC_Sinking_Rate     ! m/yr sinking velocity -> mol/m3
     $              / 1.d3                 ! mol/l
               poc_profile(1) = poc_profile(1) + poc_inv(i,j,1)
               n_poc_profile(1) = n_poc_profile(1) + 1
            endif
         enddo
      enddo

c     poc inv subsurface
      DO j=jl1,jle
         DO i=1,ie
            do k=2,ke
               if(prorca(i,j) .GT. 0.d0) then
                  poc_inv(i,j,k) = poc_inv(i,j,1)
     $                * poc_flux_frac(k)
                  poc_profile(k) = poc_profile(k) + poc_inv(i,j,k)
                  n_poc_profile(k) = n_poc_profile(k) + 1
               endif
            enddo
         enddo
      enddo

#ifdef Hg_Deposition

c     Hg chemistry in the surface layer
      DO j=jl1,jle
         DO i=1,ie
            if(prorca(i,j) .GT. 0.d0) then
               do k = 1, ke
                  
                  rate_constants = 0.d0

                  if( k .EQ. 1 ) then  ! degassing
                     rate_constants( i0, i0 ) = 10.d0   
                     rate_constants( iDM, iDM ) = 10.d0
                  endif

                  photo_scale = exp( - intw(k)*1.d0 / 50.d0 )

                  rate_scale = poc_inv(i,j,k) ! mol/l
     $                 * 1.d6   ! MethylationRateScale ! want 3/yr at surface

                  rate_constants( i2P, iMM ) = rate_scale
                  rate_constants( iMM, i0 ) = rate_scale ! replaces semeniuk k4
     $                 * ( 5. + 15. * photo_scale )  ! 5% MM/2+ at surface, 20% deep
                  rate_constants( i0, i2P ) = rate_scale ! couples with prev for k4
     $                 * 100.d0                      ! results in 1% Hg0 / 2+ 

                  rate_constants( iMM, iDM ) = rate_scale
     $                 * 0.1d0                       ! semeniuk k3
                  rate_constants( iDM, iMM ) = rate_scale
     $                 * 0.1d0                       ! semeniuk k5
                  rate_constants( i2P, iDM ) = rate_scale
     $                 * 0.1d0                       ! semeniuk k2

c                  rate_constants( i2P, i0 ) = 2.d-2
c#ifdef Hg_Photo_Red_2P
c     $                 + 0.1d0   ! not sure where this comes from
c     $                 * prlat(i,j)  
c     $                 * photo_scale
c#endif

c#ifdef Hg_Photo_Ox
c               rate_surface( iMM, i2P ) =
c     $              rate_surface( iMM, i2P ) + 1.2d-1 ! photo oxidation
c#ifdef Hg_Photo_Chem_Lat
c     $              * prlat(i,j)
c#endif
c#endif

c#endif

#ifdef Hg_Sinking_Implicit
                  rate_surface( i2P, i2P ) = 1.d0 ! rate dependence on hg_2p
     $                 * ( 1.d0 -
     $                     1 /
     $                     ( Hg_2P_Binding_Constant
     $                     * poc_inv(i,j,1)
     $                     + 1
     $                     )
     $                   )                    ! hg_2p_bound 
     $                 * 1.d3 * Hg_Sinking_Rate     ! hg_2p_sinking_flux
     $                 / ( ddz(i,j,1)/1.d2 ) / 1.d3  ! time tendency on hg_2p
#endif

                  mdf_alpha = 0.d0
                  mif_alpha = 0.d0

#ifdef Hg_2P_0_Fractionation
                  mdf_alpha( i2P, i0 ) = -4.d0
#endif

#ifdef Hg_2P_MM_Fractionation
                  mdf_alpha( i2P, iMM) = -3.5d0
#endif

#ifdef Hg_MM_0_Fractionation
                  mdf_alpha( iMM, i0) = -3.5d0
#endif

#ifdef Hg_Particles_Fractionation
                  mdf_alpha( i2P, i2P ) = -3.5d0 ! particles
#endif

#ifdef Hg_Photo_2P_0_Fractionation
                  mdf_alpha( i2P, i0 ) = -2.5
#endif

#ifdef Hg_Photo_MM_0_Fractionation
                  mdf_alpha( iMM, i0 ) = -2.0
#endif

                  if( k .EQ. 1) then
#ifdef Hg_Degas_0_Fractionation
                     mdf_alpha( i0, i0 ) = -4.d0 ! degassing
#endif

#ifdef Hg_Degas_DM_Fractionation
                     mdf_alpha( iDM, iDM ) = -4.d0 ! degassing
#endif
                  endif

#ifdef Hg_MIF_2P_0
                  mif_alpha( i2P, i0 ) = -3.5
#endif

#ifdef Hg_MIF_MM_0
                  mif_alpha( iMM, i0 ) = -5.5
#endif
                  do iFrom = 1, 4
                     do iTo = 1, 4
                        epsilon_199( iFrom, iTo ) = 1.d0
     $                    + ( mdf_alpha( iFrom, iTo )
     $                      + mif_alpha( iFrom, iTo )
     $                      )
     $                    / 1.d3
                        epsilon_202( iFrom, iTo ) = 1.d0
     $                    + ( mdf_alpha( iFrom, iTo )
     $                    * Hg_Mass_Dep_202_199
     $                      ) / 1.d3
                        rate_199( iFrom, iTo ) =
     $                    rate_constants( iFrom, iTo)
     $                    * epsilon_199( iFrom, iTo )
                     rate_202( iFrom, iTo ) =
     $                    rate_constants( iFrom, iTo )
     $                    * epsilon_202( iFrom, iTo )
                  enddo
               enddo

               if( k .EQ. 1 ) then
                  call load_surface_a( rate_constants, a, b )
                  hg_deposition(i,j) = - b(i2P)

                  call gaussj(a, 4, 4, b, 1, 1)

                  hg_2p(i,j,1) = b(i2P)
                  hg_0(i,j,1) = b(i0)
                  hg_mm(i,j,1) = b(iMM)
                  hg_dm(i,j,1) = b(iDM)

c              acts as a nonconservative top boundary condition
                  hg_0_degassing(i,j) = - hg_0(i,j,1)
     $                 * rate_surface( i0, i0 )
                  hg_dm_degassing(i,j) = - hg_dm(i,j,1)
     $                 * rate_surface( iDM, iDM )
#ifdef Hg_Sinking               
                  hg_particle_src(i,j,1) = - hg_2p(i,j,1)
     $                 * rate_surface( i2P, i2P )
#endif
                  call load_surface_a( rate_199, a, b ) 

                  call gaussj(a, 4, 4, b, 1, 1)
                  
                  hg_2p_199(i,j,1) = b(i2P)
                  hg_0_199(i,j,1) = b(i0)
                  hg_mm_199(i,j,1) = b(iMM)
                  hg_dm_199(i,j,1) = b(iDM)
                  
                  call load_surface_a( rate_202, a, b )
                  
                  call gaussj(a, 4, 4, b, 1, 1)
                  
                  hg_2p_202(i,j,1) = b(i2P)
                  hg_0_202(i,j,1) = b(i0)
                  hg_mm_202(i,j,1) = b(iMM)
                  hg_dm_202(i,j,1) = b(iDM)

               else

                  call load_subsurface_a( rate_constants, a, b )
                  call gaussj(a, 3, 4, b, 1, 1)
                  call unpack_subsurface_b( hg_tot(i,j,k), b,
     $                 hg_2p(i,j,k), hg_0(i,j,k), 
     $                 hg_mm(i,j,k), hg_dm(i,j,k) )

                  call load_subsurface_a( rate_199, a, b )
                  call gaussj(a, 3, 4, b, 1, 1)
                  call unpack_subsurface_b( hg_199_tot(i,j,k), b,
     $                 hg_2p_199(i,j,k),
     $                 hg_0_199(i,j,k), hg_mm_199(i,j,k),
     $                 hg_dm_199(i,j,k) )

                  call load_subsurface_a( rate_202, a, b )
                  call gaussj(a, 3, 4, b, 1, 1)
                  call unpack_subsurface_b( hg_202_tot(i,j,k), b,
     $                 hg_2p_202(i,j,k),
     $                 hg_0_202(i,j,k), hg_mm_202(i,j,k),
     $                 hg_dm_202(i,j,k) )
                  
               endif

            endif
         enddo
      enddo


c#ifdef Hg_Advection
c     the component species have been set, update the totals
      do iT = 0, 2
         ca(:,:,1,7+iT) =        ! hg_tot
     $          ca(:,:,1,10+iT*4)  ! hg_2p
     $        + ca(:,:,1,11+iT*4)  ! hg_mm
     $        + ca(:,:,1,12+iT*4)  ! hg_dm
     $        + ca(:,:,1,13+iT*4)  ! hg_0
      enddo
c#endif

#else

      ca(:,:,1,7:9) = 1.d-12

#endif /* Hg_Deposition */

#ifdef Hg_Sinking

c     hg_2P binding to poc
      DO j=jl1,jle
         DO i=1,ie
            do k=1,ke
               if(prorca(i,j) .GT. 0.d0 .AND.
     $            ddz(i,j,k) .GT. 1.d0) then
                  hg_2P_bound(i,j,k) = hg_2P(i,j,k)
     $                 * ( 1.d0 -
     $                     1 /
     $                     ( Hg_2P_Binding_Constant
     $                     * poc_inv(i,j,k)
     $                     + 1
     $                     )
     $                   )
                  hg_2P_202_bound(i,j,k) = hg_2P_202(i,j,k)
     $                 * ( 1.d0 -
     $                     1 /
     $                     ( Hg_2P_Binding_Constant
     $                     * poc_inv(i,j,k)
     $                     + 1
     $                     )
     $                   )
     $                 * ( 1.d0
     $                   + Hg_2P_Bind_MDF_Alpha
     $                   * Hg_Mass_Dep_202_199 / 1000.d0
     $                   ) 
                  hg_2P_199_bound(i,j,k) = hg_2P_199(i,j,k)
     $                 * ( 1.d0 -
     $                     1 /
     $                     ( Hg_2P_Binding_Constant
     $                     * poc_inv(i,j,k)
     $                     + 1
     $                     )
     $                   )
     $                 * ( 1.d0
     $                   + Hg_2P_Bind_MDF_Alpha
     $                   / 1000.d0 )

               endif
            enddo
         enddo
      enddo

c     hg_2P sinking fluxes
      hg_2p_global_sinking_flux = 0.d0
      DO j=jl1,jle
         DO i=1,ie
            do k=1,ke
               if(prorca(i,j) .GT. 0.d0 .AND.
     $            ddz(i,j,k) .GT. 1.d0) then
                  hg_2P_sinking_flux(i,j,k) =
     $                   hg_2P_bound(i,j,k)     ! about 1e-13 m/L
     $                 * 1.d3                   ! mol/m3
     $                 * Hg_Sinking_Rate       ! m/yr gives mol/m2yr
                  hg_2p_global_sinking_flux(k) =
     $                   hg_2p_global_sinking_flux(k)
     $                 + hg_2p_sinking_flux(i,j,k)
                  hg_2P_202_sinking_flux(i,j,k) =
     $                   hg_2P_202_bound(i,j,k)
     $                 * 1.d3
     $                 * Hg_Sinking_Rate       ! m/yr gives mol/m2yr
                  hg_2P_199_sinking_flux(i,j,k) =
     $                   hg_2P_199_bound(i,j,k)
     $                 * 1.d3
     $                 * Hg_Sinking_Rate       ! m/yr gives mol/m2yr
               endif
            enddo
         enddo
      enddo

c     poc release of hg_2P alters the total Hg pools
      DO j=jl1,jle
         DO i=1,ie
            do k=2,ke
               if(prorca(i,j) .GT. 0.d0 .AND.
     $            ddz(i,j,k) .GT. 1.d0) then
                  hg_tot(i,j,k) = hg_tot(i,j,k)  ! mol/m
     $                 + ( hg_2P_sinking_flux(i,j,k-1) ! mol/m2 yr
     $                   - hg_2P_sinking_flux(i,j,k) ! mol/m2 yr
     $                   )
     $                 / ( ddz(i,j,k)/1.d2 )         ! meters gives mol/m3 yr
     $                 / 1.d3                        ! mol/l yr
                  hg_particle_src(i,j,k) =
     $                   ( hg_2P_sinking_flux(i,j,k-1) ! mol/m2 yr
     $                   - hg_2P_sinking_flux(i,j,k) ! mol/m2 yr
     $                   )
     $                 / ( ddz(i,j,k)/1.d2 )         ! meters gives mol/m3 yr
     $                 / 1.d3                        ! mol/l yr
                  hg_202_tot(i,j,k) = hg_202_tot(i,j,k)  ! mol/m
     $                 + ( hg_2P_202_sinking_flux(i,j,k-1) ! mol/m2 yr
     $                   - hg_2P_202_sinking_flux(i,j,k) ! mol/m2 yr
     $                   )
     $                 / ( ddz(i,j,k)/1.d2 )         ! meters gives mol/m3 yr
     $                 / 1.d3                        ! mol/l yr
                  hg_199_tot(i,j,k) = hg_199_tot(i,j,k)  ! mol/m
     $                 + ( hg_2P_199_sinking_flux(i,j,k-1) ! mol/m2 yr
     $                   - hg_2P_199_sinking_flux(i,j,k) ! mol/m2 yr
     $                   )
     $                 / ( ddz(i,j,k)/1.d2 )         ! meters gives mol/m3 yr
     $                 / 1.d3                        ! mol/l yr
               endif
            enddo
         enddo
      enddo

#endif /* Hg_Sinking */

      return
      end

      subroutine load_surface_a(rates, a, b)

      real rates(4,4), a(4,4), b(4)

      a = 0
      b = 0

      do i = 1, 4
         a(i,i) = a(i,i) - rates(i,i)
         do j = 1, 4
            if( j .NE. i ) then
               a(i,i) = a(i,i) - rates( i, j ) ! diagonal sink terms
               a(i,j) = a(i,j) + rates( j, i )
            endif
         enddo
      enddo

      b(i2P) = - Hg_2P_Atm_Dep_Rate 

      return
      end

      subroutine load_subsurface_a(rates, a, b)
c     assume Hg2+ = 1.0, find the other values

c                 Hg0       mm        dm

c Hg0 budget    | -K02      0         0    ||  Hg0  |   | -K20  |
c mm budget     | 0         -Km2-Kmd  Kdm  ||  mm   | = | -K2m  |
c dm budget     | 0         Kmd       -Kdm ||  dm   |   | -D2d  |

      real rates(4,4), a(4,4), b(4)

      a = 0
      b = 0
      do i = 1, 3
         do j = 1, 4
            if( i .NE. j ) then
               a( i, i ) = a( i, i ) - rates( i, j )
               a( i, j ) = a( i, j ) + rates( j, i )
            endif
         enddo
         b( i ) = - rates( i2P, i )
      enddo

      return
      end

      subroutine unpack_subsurface_b( hg_tot, b,
     $     hg_2p, hg_0, hg_mm, hg_dm )
      real b(3), hg_2p, hg_0, hg_mm, hg_dm

      totScale = 1.d0 + b(1) + b(2) + b(3)
      hg_2P = 1.d0 / totScale * hg_tot
      hg_0  = b(i0) / totScale * hg_tot
      hg_mm = b(iMM) / totScale * hg_tot
      hg_dm = b(iDM) / totScale * hg_tot

      return
      end


      SUBROUTINE gaussj(a,n,np,b,m,mp)
       
C        numerical recipes, pages 28-29

       PARAMETER (nmax=600)
       DIMENSION a(np,np), b(np,mp)
       DIMENSION ipiv(nmax)
       DIMENSION indxr(nmax), indxc(nmax)
       DO 11 j=1,n
         ipiv(j)=0
 11    CONTINUE
       DO 22 i=1,n
         big=0.
         DO 13 j=1,n
           IF(ipiv(j).NE.1) then
             DO 12 k=1,n
               IF(ipiv(k).EQ.0) then
                 IF(abs(a(j,k)).ge.big) then
                   big=abs(a(j,k))
                   irow=j
                   icol=k
                 ENDIF
               ELSE IF(ipiv(k).GT.1) then
                 PAUSE 'singular matrix'
               ENDIF
 12          CONTINUE
           ENDIF
 13      CONTINUE
         ipiv(icol)=ipiv(icol)+1
         IF(irow.NE.icol) then
           DO 14 l=1,n
             dum=a(irow,l)
             a(irow,l)=a(icol,l)
             a(icol,l)=dum
 14        CONTINUE
           DO 15 l=1,m
             dum=b(irow,l)
             b(irow,l)=b(icol,l)
             b(icol,l)=dum
 15        CONTINUE
         ENDIF
         indxr(i)=irow
         indxc(i)=icol
         IF(a(icol,icol).EQ.0.) PAUSE 'singular matrix'
         pivinv=1./a(icol,icol)
         a(icol,icol)=1.
         DO 16 l=1,n
           a(icol,l)=a(icol,l)*pivinv
 16      CONTINUE
         DO 17 l=1,m
           b(icol,l)=b(icol,l)*pivinv
 17      CONTINUE
         DO 21 ll=1,n
           IF(ll.NE.icol) then
             dum=a(ll,icol)
             a(ll,icol)=0.
             DO 18 l=1,n
               a(ll,l)=a(ll,l)-a(icol,l)*dum
 18          CONTINUE
             DO 19 l=1,m
               b(ll,l)=b(ll,l)-b(icol,l)*dum
 19          CONTINUE
           ENDIF
 21      CONTINUE
 22    CONTINUE
       DO 24 l=n,1,-1
         IF(indxr(l).NE.indxc(l)) then
           DO 23 k=1,n
             dum=a(k,indxr(l))
             a(k,indxr(l))=a(k,indxc(l))
             a(k,indxc(l))=dum
 23        CONTINUE
         ENDIF
 24    CONTINUE
       RETURN
       END


#ifdef OldShit

      subroutine find_subsurface_proportions( fractions )

      real fractions(4)
      real a(3,3),b(3)

      a = 0
      a(1,1) = - Hg_0_2P_Rate
      b(1)   = - Hg_2P_0_Rate
      a(2,2) = - Hg_MM_2P_Dark_Rate - Hg_MM_DM_Rate
      a(2,3) =   Hg_DM_MM_Rate
      b(2)   = - Hg_2P_MM_Rate
      a(3,2) =   Hg_MM_DM_Rate
      a(3,3) = - Hg_DM_MM_Rate
      b(3)   = - Hg_2P_DM_Rate
      
      call gaussj(a, 3, 3, b, m, 1)

      totScale = 1d0 + b(1) + b(2) + b(3)
      fraction(1) = 1d0 / totScale
      fraction(2) = b(1) / totScale
      fraction(3) = b(2) / totScale
      fraction(4) = b(3) / totScale
      
      return
      end
                  


               a = 0
               b = 0

               do i = 1, 4
                  do j = 1, 4
                     a(i,i) = -rate( i, j )  ! diagonal sink terms
                     a(i,j) = 

                  do j = 1, 4
                     a(i,j) = 

               a(1,1) = - Hg_2P_0_Phot_Rate
     $                  - Hg_2P_0_Dark_Rate
     $                  - Hg_2P_mm_Rate
     $                  - Hg_2P_dm_Rate
               a(2,1) = Hg_0_2P_Dark_Rate
               a(3,1) = Hg_MM_2P_Rate
               b(1) = - Hg_2P_Atm_Dep_Rate

               a(2,1) = Hg_2P_0_Phot_Rate
     $                + Hg_2P_0_Dark_Rate
               a(2,2) = - Hg_Degas_Rate
     $                  - Hg_0_2P_Dark_Rate
     $                  - Hg_0_2P_Phot_Rate
               a(2,3) = Hg_MM_0_Phot_Rate

               a(3,1) = Hg_2P_MM_Rate
               a(3,3) = - Hg_MM_0_Phot_Rate
     $                  - Hg_MM_2P_Rate
     $                  - Hg_MM_DM_Rate
               a(3,4) = Hg_DM_MM_Rate

               a199 = a
               a202 = a

               a199(1,1) = - Hg_2P_0_Phot_Rate
     $                   * ( 1.d0 + Hg_2P_0_Phot_MDF/1.d3 )
     $                  - Hg_2P_0_Dark_Rate
     $                   * ( 1.d0 + Hg_2P_0_Dark_MDF/1.d3 )
     $                  - Hg_2P_mm_Rate
     $                  - Hg_2P_dm_Rate
               a202(1,1) = - Hg_2P_0_Phot_Rate
     $                   * ( 1.d0
     $                       + ( Hg_2P_0_Phot_MDF
     $                         + Hg_2P_0_Phot_MIF
     $                         )
     $                       / Hg_Mass_Dep_202_199 / 1.d3 )
     $                  - Hg_2P_0_Dark_Rate
     $                  * ( 1.d0
     $                     + Hg_2P_0_Dark_MDF
     $                       / Hg_Mass_Dep_202_199 / 1.d3
     $                    )
     $                  - Hg_2P_mm_Rate
     $                  - Hg_2P_dm_Rate

               a199(2,1) = Hg_2P_0_Phot_Rate
     $                   * ( 1.d0 + Hg_2P_0_Phot_MDF / 1.d3 )
     $                + Hg_2P_0_Dark_Rate
     $                   * ( 1.d0 + Hg_2P_0_Dark_MDF / 1.d3 )
               a202(2,1) = Hg_2P_0_Phot_Rate
     $                   * ( 1.d0
     $                     + ( Hg_2P_0_Phot_MDF
     $                       + Hg_2P_0_Phot_MIF
     $                       )
     $                       / Hg_Mass_Dep_202_199 / 1.d3 )

     $                + Hg_2P_0_Dark_Rate
     $                   * ( 1.d0 + Hg_2P_0_Dark_MDF / 1.d3 )
               a199(2,2) = - Hg_Degas_Rate
     $                   * ( 1.d0 + Hg_Degas_MDF / 1.d3 )
     $                  - Hg_0_2P_Dark_Rate
     $                  - Hg_0_2P_Phot_Rate
               a202(2,2) = - Hg_Degas_Rate
     $                   * ( 1.d0
     $                     + Hg_Degas_MDF
     $                     / Hg_Mass_Dep_202_199 / 1.d3 )
     $                  - Hg_0_2P_Dark_Rate
     $                  - Hg_0_2P_Phot_Rate

               a199(3,1) = Hg_2P_MM_Rate
     $                   * ( 1.d0 + Hg_2P_MM_MDF / 1.d3 )
               a202(3,1) = Hg_2P_MM_Rate
     $                   * ( 1.d0
     $                     + Hg_2P_MM_MDF
     $                     / Hg_Mass_Dep_202_199 / 1.d3 )
               a199(3,3) = - Hg_MM_0_Phot_Rate
     $                   * ( 1.d0 + Hg_2P_MM_MDF / 1.d3 )
     $                  - Hg_MM_2P_Rate
     $                  - Hg_MM_DM_Rate






                 

               hg_2P(i,j,k) = Hg_2P_Atm_Dep_Rate
     $              / ( Hg_2P_0_Phot_Rate
     $                + Hg_2P_0_Phot_Rate
     $                + Hg_2P_DM_Rate
     $                )
c                   from a budget for Hg2+, in = out
c                   src            sink
c                   deposition = 2P ( K to 0 + K to mm )
               hg_2P_199(i,j,k) =
     $              ( Hg_2P_Atm_Dep_Rate
     $              * 1.d0 + Hg_2P_Atm_Dep_MDF / 1.d3
     $              )
     $              / ( ( Hg_2P_0_Phot_Rate
     $                  * 1.d0 + Hg_2P_0_Phot_MDF
     $                  )
     $                + Hg_2P_0_Dark_Rate
     $                + Hg_2P_DM_Rate
     $                )
               hg_2P_202(i,j,k) =
     $              ( Hg_2P_Atm_Dep_Rate
     $              * 1.d0
     $                + ( Hg_2P_Atm_Dep_MDF
     $                  + Hg_2P_Atm_Dep_MIF
     $                  )
     $                  / Hg_Mass_Dep_202_199
     $                  / 1.d3
     $              )
     $              / ( ( Hg_2P_0_Phot_Rate
     $                  * 1.d0
     $                    + ( Hg_2P_0_Phot_MDF
     $                      + Hg_2P_0_Phot_MIF
     $                      )
     $                  )
     $                + Hg_2P_0_Dark_Rate
     $                  * (1.d0 + Hg_2P_0_Dark_MDF / 1.d3 )
     $                + Hg_2P_DM_Rate
     $                )

               hg_0(i,j,k) = hg_2P(i,j,k)
     $              * ( Hg_2P_0_Dark_Rate
     $                + Hg_2P_0_Phot_Rate
     $                )
     $              / Hg_Degas_Rate
c                   budget for Hg_0, from Hg2+ balancing degassing
               hg_0_199(i,j,k) = hg_2P_199(i,j,k)
     $              * ( Hg_2P_0_Dark_Rate
     $                + Hg_2P_0_Phot_Rate
     $                  * ( 1.d0 + Hg_2P_0_Phot_MDF / 1.d3 )
     $                )
     $              / Hg_Degas_Rate
     $                * ( 1.d0 + Hg_Degas_MDF / 1.d3 )
               hg_0_202(i,j,k) = hg_2P_202(i,j,k)
     $              * ( Hg_2P_0_Dark_Rate
     $                + Hg_2P_0_Phot_Rate
     $                  * ( 1.d0
     $                    + ( Hg_2P_0_Phot_MDF
     $                      + Hg_2P_0_Phot_MIF
     $                      )
     $                      / 1.d3
     $                      / Hg_Mass_Dep_202_199
     $                    )
     $                )
     $              / Hg_Degas_Rate
     $                * ( 1.d0
     $                  + Hg_Degas_MDF
     $                    / Hg_Mass_Dep_202_199
     $                    / 1.d3
     $                  )

c     solve simultaneously for mm and dm

c                  mm        dm

c mm budget     | -Km2-Kmd   Kdm         || mm | = | -Hg2+ K2m |
c dm budget     | Kmd        -Kdegas-Kdm || dm |   | -Hg2+ K2d |           

               a = 0

               a(1,1) = - Hg_MM_2P_Rate
     $                  - Hg_MM_0_Phot_Rate
     $                  - Hg_MM_DM_Rate
               a(1,2) = Hg_DM_MM_Rate
               b(1)   = - Hg_2P_MM_Rate

               a(2,1) = Hg_MM_DM_Rate
               a(2,2) = - Hg_Degas_Rate
     $                  - Hg_DM_MM_Rate
               b(2)   = - * Hg_2P_DM_Rate

               a(3,1) = Hg_2P_0_Phot_Rate
               a(3,3) = - Hg_Degas_Rate
     $                  - Hg_0_2P_Dark_Rate
     $                  - Hg_0_2P_Phot_Rate
               b(3) = - Hg_2P_0_Dark_Rate
     $                - Hg_2P_0_Phot_Rate

               a_prime = a
               b_prime = b

               call gaussj(a, 2, 3, b, m, 1)

               totScale = 1.d0 + b(1) + b(2) + b(3)
               totHg = hg_2P(i,j,k)
     $              + hg_0(i,j,k)
     $              + hg_mm(i,j,k)
     $              + hg_dm(i,j,k)
               hg_2P(i,j,k) = 1.d0 / totScale * totHg
               hg_0(i,j,k)     = b(1) / totScale * totHg
               hg_mm(i,j,k)    = b(2) / totScale * totHg
               hg_dm(i,j,k)    = b(3) / totScale * totHg

               a(1,1) = - Hg_MM_2P_Rate
     $                  - Hg_MM_0_Phot_Rate
     $                    * ( 1.d0 + Hg_MM_0_MDF / 1.d3 )
     $                  - Hg_MM_DM_Rate
               a(1,2) = Hg_DM_MM_Rate
               b(1)   = - Hg_2P_MM_Rate
     $                    * ( 1.d0 + Hg_2P_MM_MDF / 1.d3 )

               a(2,1) = Hg_MM_DM_Rate
               a(2,2) = - Hg_Degas_Rate
     $                    * ( 1.d0 + Hg_Degas_MDF / 1.d3 )
     $                  - Hg_DM_MM_Rate
               b(2)   = - * Hg_2P_DM_Rate

               a(3,1) = Hg_2P_0_Phot_Rate
     $                * ( 1.d0 + Hg_2P_0_Phot_MDF / 1.d3 )
               a(3,3) = - Hg_Degas_Rate
     $                    * ( 1.d0 + Hg_Degas_MDF / 1.d3 )
     $                  - Hg_0_2P_Dark_Rate
     $                  - Hg_0_2P_Phot_Rate
               b(3) = - Hg_2P_0_Dark_Rate
     $                - Hg_2P_0_Phot_Rate
     $                    * ( 1.d0 + Hg_2P_0_Phot_MDF / 1.d3 )


               a = a_prime
               b = b_prime
               a(

            endif
         enddo
      enddo


                  a = 0
                  a(1,1) = - Hg_0_2P_Rate
                  b(1)   = - Hg_2P_0_Rate
                  a(2,2) = - Hg_MM_2P_Dark_Rate - Hg_MM_DM_Rate
                  a(2,3) =   Hg_DM_MM_Rate
                  b(2)   = - Hg_2P_MM_Rate
                  a(3,2) =   Hg_MM_DM_Rate
                  a(3,3) = - Hg_DM_MM_Rate
                  b(3)   = - Hg_2P_DM_Rate
      
                  call gaussj(a, 3, 3, b, m, 1)

                  totScale = 1.d0 + b(1) + b(2) + b(3)
                  totHg = hg_2P(i,j,k)
     $                 + hg_0(i,j,k)
     $                 + hg_mm(i,j,k)
     $                 + hg_dm(i,j,k)

                  hg_2P(i,j,k) = 1.d0 / totScale * totHg
                  hg_0(i,j,k)     = b(1) / totScale * totHg
                  hg_mm(i,j,k)    = b(2) / totScale * totHg
                  hg_dm(i,j,k)    = b(3) / totScale * totHg

               endif
            enddo
         enddo
      enddo













C     microbial methylation
      hg_meth_prod_total = 0.
      DO j=jl1,jle
         DO i=1,ie
            if(prorca(i,j) .GT. 0.d0) then
               hg2plus_meth_rate(i,j,1) =
     $             Hg_2Plus_Surf_Meth_Rate 
               do k=2,ke
                  if(ddz(i,j,k) .GT. 1.d0 .AND.
     $                 oxygen(i,j,k) .GT. 0.d0) then
                     hg2plus_meth_rate(i,j,k) =
     $                      Hg_2Plus_Deep_Meth_Rate
     $                    * poc_inv(i,j,k)
c     $                    * prorca(i,j) ! proportional to poc remin rate
c     $                      * dmin3(i,j,k)
c     $                      * (tobox/ddz(i,j,k))
     $                    * oxygen(i,j,k) ! boosted by low o2
     $                    / ( oxygen(i,j,k)
     $                      + Hg_2Plus_Meth_Oxygen_Critical
     $                    )
                  endif
               enddo
               do k=1,ke
                  hg_2plus(i,j,k) = hg_2plus(i,j,k)
     $                 - hg_2plus(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
                  hg_2plus_202(i,j,k) = hg_2plus_202(i,j,k)
     $                 - hg_2plus_202(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
     $              * ( 1.d0 + Hg_2Plus_Meth_MDF_Alpha / 1.d3 )
                  hg_2plus_199(i,j,k) = hg_2plus_199(i,j,k)
     $                 - hg_2plus_199(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
     $              * ( 1.d0
     $                + Hg_2P_Meth_MDF_Alpha
     $                / Hg_Mass_Dep_202_199
     $                / 1.d3
     $                )
                  hg_meth(i,j,k) = hg_meth(i,j,k)
     $                 + hg_2plus(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
                  hg_meth_202(i,j,k) = hg_meth_202(i,j,k)
     $                 + hg_2plus_202(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
     $              * ( 1.d0 + Hg2Plus_Meth_MDF_Alpha / 1.d3 )
                  hg_meth_199(i,j,k) = hg_meth_199(i,j,k)
     $                 + hg_2plus_199(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
     $              * ( 1.d0
     $                + Hg2Plus_Meth_MDF_Alpha
     $                / Hg_Mass_Dep_202_199
     $                / 1.d3 )
c                  hg2plus_meth_rate(i,j,k) =
c     $                 hg2plus_meth_rate(i,j,k)
c     $                 * hg_2plus(i,j,k) ! for netcdf diagnostic
                  hg_meth_prod_total = hg_meth_prod_total
     $                 + hg_2plus(i,j,k)
     $                 * hg2plus_meth_rate(i,j,k)
     $              * dzdl(i,j,k) * dphi
               enddo
            endif ! ddz(i,j,k)>1
         enddo
      enddo

c     methyl hg microbial demethylation
      hg_microbe_demeth_total = 0.d0
      DO j=jl1,jle
         DO i=1,ie
            do k=1,ke
               if(ddz(i,j,k) .GT. one .AND.
     $              hg_meth(i,j,k) .GT. 0.d0) then
                  hg_microb_demeth_rate(i,j,k) =
     $              Hg_Microbial_Demethylation_Rate
     $              * hg_meth(i,j,k)
                  hg_meth(i,j,k) = hg_meth(i,j,k)
     $              - Hg_Microbial_Demethylation_Rate
     $              * hg_meth(i,j,k)
                  hg_meth_202(i,j,k) = hg_meth_202(i,j,k)
     $              - Hg_Microbial_Demethylation_Rate
     $              * hg_meth_202(i,j,k)
     $              * ( 1.d0 + Hg_Microbial_Demeth_MDF_Alpha / 1.d3 )
                  hg_meth_199(i,j,k) = hg_meth_199(i,j,k)
     $              - Hg_Microbial_Demethylation_Rate
     $              * hg_meth_199(i,j,k)
     $              * ( 1.d0
     $                + ( Hg_Microbial_Demeth_MDF_Alpha
     $                  / Hg_Mass_Dep_202_199
     $                  ) / 1.d3 )
                  hg_microbe_demeth_total = hg_microbe_demeth_total
     $              + hg2plus_microb_demeth_rate(i,j,k)
     $              * dzdl(i,j,k) * dphi
               endif
            enddo
         enddo
      enddo

      hg_photo_demeth_total = 0.0
      DO j=jl1,jle
         DO i=1,ie
            hg_photo_demeth_rate(i,j,1) =
     $           Hg_Photo_Demeth_Rate
     $           * hg_meth(i,j,1)
            hg_meth(i,j,1) = hg_meth(i,j,1)
     $           - Hg_Photo_Demeth_Rate
     $           * hg_meth(i,j,1)
            hg_meth_202(i,j,1) = hg_meth_202(i,j,1)
     $           - Hg_Photo_Demeth_Rate
     $           * hg_meth_202(i,j,1)
     $              * ( 1.d0 + Hg_Photo_Demeth_MDF_Alpha / 1.d3 )
            hg_meth_199(i,j,1) = hg_meth_199(i,j,1)
     $           - Hg_Photo_Demeth_Rate
     $           * hg_meth_199(i,j,1)
     $              * ( 1.d0
     $                + ( Hg_Photo_Demeth_MDF_Alpha
     $                  + Hg_Photo_Demeth_MIF_Alpha
     $                  )
     $                  / Hg_Mass_Dep_202_199
     $                  / 1.d3 )


            hg_photo_demeth_total = hg_photo_demeth_total
     $           + hg_photo_demeth_rate(i,j,1)
     $           * dzdl(i,j,1) * dphi
         enddo
      enddo






      subroutine hg_microbial_reduction

      INCLUDE 'parameter.include'
      INCLUDE 'equivalence.include'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.chemis'

      DO j=jl1,jle
         DO i=1,ie
            do k=1,ke
               rate = Hg_Microbial_Reduction_Rate
     $              * hg_2plus(i,j,k)

               hg_2plus(i,j,k) = hg_2plus(i,j,k)
     $              - rate
               hg_2plus_202(i,j,k) = hg_2plus_202(i,j,k)
     $              - rate
     $              * Hg_Microbial_Reduc_MDF_Alpha
               hg_2plus_199(i,j,k) = hg_2plus_199(i,j,k)
     $              - rate
     $              * ( Hg_Microbial_Reduc_MDF_Alpha
     $                * Hg_Mass_Dep_202_199
     $                + Hg_Microbial_Reduc_MIF_Alpha )

               hg_0(i,j,k) = hg_0(i,j,k)
     $              + rate
               hg_0_202(i,j,k) = hg_0_202(i,j,k)
     $              + rate
     $              * Hg_Microbial_Reduc_MDF_Alpha
               hg_0_199(i,j,k) = hg_0_199(i,j,k)
     $              + rate
     $              * ( Hg_Microbial_Reduc_MDF_Alpha
     $                * Hg_Mass_Dep_202_199
     $                + Hg_Microbial_Reduc_MIF_Alpha )
            enddo
         enddo
      enddo
      return
      end

      subroutine hg_photo_reduction

      INCLUDE 'parameter.include'
      INCLUDE 'equivalence.include'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.chemis'

      DO j=jl1,jle
         DO i=1,ie
            rate = hg_2plus(i,j,1)
     $           * Hg_Photo_Reduction_Rate

            hg_2plus(i,j,1) = hg_2plus(i,j,1)
     $           - rate
            hg_2plus_202(i,j,1) = hg_2plus_202(i,j,1)
     $           - rate
     $           * Hg_Photo_Red_MDF_Alpha
            hg_2plus_199(i,j,1) = hg_2plus_199(i,j,1)
     $           - rate
     $           * ( Hg_Photo_Red_MDF_Alpha
     $             * Hg_Mass_Dep_202_199
     $             + Hg_Photo_Red_MIF_Alpha )

            hg_0(i,j,1) = hg_0(i,j,1)
     $           + rate
            hg_0_202(i,j,1) = hg_0_202(i,j,1)
     $           + rate
     $           * Hg_Photo_Red_MDF_Alpha
            hg_0_199(i,j,1) = hg_0_199(i,j,1)
     $           + rate
     $           * ( Hg_Photo_Red_MDF_Alpha
     $             * Hg_Mass_Dep_202_199
     $             + Hg_Photo_Red_MIF_Alpha )
         enddo
      enddo
      return
      end

      subroutine hg_photo_demethylation(hg_photo_demeth_total)

      INCLUDE 'parameter.include'
      INCLUDE 'equivalence.include'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.chemis'
      include 'common.topogr'
      include 'common.biocon'


c            hg_0(i,j,1) = hg_0(i,j,1)
c     $           + rate
c            hg_0_202(i,j,1) = hg_0_202(i,j,1)
c     $           + rate
c     $           * Hg_Photo_Demethyl_MDF_Alpha
c            hg_0_199(i,j,1) = hg_0_199(i,j,1)
c     $           + rate
c     $           * ( Hg_Photo_Demethyl_MDF_Alpha
c     $             * Hg_Mass_Dep_202_199
c     $             + Hg_Photo_Demethyl_MIF_Alpha )
         enddo
      enddo
      return
      end

      subroutine hg_0_degassing

      INCLUDE 'parameter.include'
      INCLUDE 'equivalence.include'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.chemis'

      DO j=jl1,jle
         DO i=1,ie
            rate = hg_0(i,j,1)
     $           * Hg_0_Degassing_Rate
            hg_0(i,j,1) = hg_0(i,j,1)
     $           - rate
            hg_0_202(i,j,1) = hg_0_202(i,j,1)
     $           - rate
            hg_0_199(i,j,1) = hg_0_199(i,j,1)
     $           - rate
         enddo
      enddo
      return
      end

#endif
      subroutine calc_hg_deltas(c198,c199,c202,d199,d202,capD199)
      
      if( c198 .GT. 0.d0 ) then
         d202 = ( c202 / c198 - 1.d0 ) * 1000.d0
         d199 = ( c199 / c198 - 1.d0 ) * 1000.d0
         capD199 = d199 - d202 / Hg_Mass_Dep_202_199
      endif

      return
      end
