
      SUBROUTINE printout(filename)

      INCLUDE '/usr/local/include/netcdf.inc'

      INCLUDE 'parameter.include'
      INCLUDE 'parameter.sediment.include'

      PARAMETER(i_out=144,j_out=72)

      INCLUDE 'common.wathic'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.thermo'
      INCLUDE 'common.topogr'
      INCLUDE 'common.production'
      INCLUDE 'common.chemis'
      INCLUDE 'common.divers'
      INCLUDE 'common.hg'
c      INCLUDE 'common.seddiag'
c      INCLUDE 'common.sediment'
      INCLUDE 'equivalence.include'

      REAL calpct(ip_sedmain_max), co3(ie,je,ke), dco3(ie,je,ke),
     $     c14(ie,je,ke),
     $     pco2(ie,je,ke), dco3bw(ie,je),
     $     caco3_erod(ip_sedmain_max)

      real*4 calpct_g(i_out,j_out),caco3_erod_g(i_out,j_out),
     $     c_advect_g(i_out,j_out),ttrcal_g(i_out,j_out)
      real*4 temg(i_out,j_out,ke), salg(i_out,j_out,ke),
     $     depthg(i_out,j_out)
      real*4 co3g(i_out,j_out,ke), dco3g(i_out,j_out,ke),
     $     pco2g(i_out,j_out,ke), c14g(i_out,j_out,ke)
      real*4 sco212g(i_out,j_out,ke),
     .  alkalig(i_out,j_out,ke)
      real*4 oxygeng(i_out,j_out,ke), phosphg(i_out,j_out,ke)
c      real*4 hg_2pg(i_out,j_out,ke), hg_mmg(i_out,j_out,ke)

      real
     $     hg_isotopes(ie,je,ke,4,5)
      real*4 ca_g(i_out,j_out,ke,nv),
     $     hg_isotopes_g(i_out,j_out,ke,4,5)
      character*8 hg_names(4), isotope_names(5)
      character*17 hg_isotope_name
      real*4 poc_invg(i_out,j_out,ke), 
     $     hg_2p_boundg(i_out,j_out,ke),
     $     hg_2p_bound_fracg(i_out,j_out,ke),
     $     hg_particle_lifetimeg(i_out,j_out,ke),
     $     hg_particle_srcg(i_out,j_out,ke),
     $     hg_depositiong(i_out,j_out),
     $     hg_surface_netg(i_out,j_out),
     $     hg_0_degassingg(i_out,j_out),
     $     hg_dm_degassingg(i_out,j_out),
     $     hg_2p_meth_rateg(i_out,j_out,ke),
     $     hg_2p_sinking_fluxg(i_out,j_out,ke),
     $     hg_2p_particle_srcg(i_out,j_out,ke),
     $     hg_microb_demeth_rateg(i_out,j_out,ke),
     $     hg_photo_demeth_rateg(i_out,j_out,ke),
     $     hg_adv_surf_srcg(i_out,j_out)
      integer hg_indices(4), hg_isotope_indices(4,5)
c      real*4 hg_0g(i_out,j_out,ke)
c      real hg_2p_d199(ie,je,ke),
c     $     hg_2p_d202(ie,je,ke),
c     $     hg_2p_capD199(ie,je,ke)
c      real hg_mm_d199(ie,je,ke),
c     $     hg_mm_d202(ie,je,ke),
c     $     hg_mm_capD199(ie,je,ke)
c      real hg_0_d199(ie,je,ke),
c     $     hg_0_d202(ie,je,ke),
c     $     hg_0_capD199(ie,je,ke)
c      real*4 hg_2p_d199g(i_out,j_out,ke),
c     $     hg_2p_d202g(i_out,j_out,ke),
c     $     hg_2p_capD199g(i_out,j_out,ke)
c      real*4 hg_mm_d199g(i_out,j_out,ke),
c     $     hg_mm_d202g(i_out,j_out,ke),
c     $     hg_mm_capD199g(i_out,j_out,ke)
c      real*4 hg_0_d199g(i_out,j_out,ke),
c     $     hg_0_d202g(i_out,j_out,ke),
c     $     hg_0_capD199g(i_out,j_out,ke)
      
      real*4 dco3bwg(i_out,j_out)
      real*4 x_grid(i_out),y_grid(j_out),z_grid(11),
     $     depth_age_sp(i_bur_rec_max)

      real orgprod(ie,je), calprod(ie,je)
      real*4 orgprodg(i_out,j_out), calprodg(i_out,j_out)

      character*80 filename
      integer vdims(3), seddims(3)
      integer start(3), count(3), sedcount(3), i_offset

      data start /1,1,1/
      data count /i_out, j_out, ke/
      data sedcount /i_out, j_out, i_bur_rec_max/
      data vdims /1, 2, 3/
      data seddims /1, 2, 4/
      data hg_names / "Hg_2plus", "MM_Hg", "DM_Hg", "Hg_0"/
      data isotope_names /"d199","d200","d202","capD199","capD200"/

      DATA z_grid/-.25,-.75,-1.50,-2.50,-4.50,-7.00,-10.00,-20.00,
     *            -30.00,-40.00,-50.00/

      do i=1, i_out
         x_grid(i) = 1.25 + 2.5 * (i-1)
      enddo

      do j=1, j_out
         y_grid(j) = -88.75 + 2.5 * (j-1)
      enddo

      do i=1, ie
         do j=1, je
            orgprod(i,j) = prorca(i,j) * ddz(i,j,1) / 100 * 1000
            calprod(i,j) = prcaca(i,j) * ddz(i,j,1) / 100 * 1000
c              mol/m2 yr = mol/l layer   m                  l/m3
         enddo
      enddo

      call regrid(tem,temg,ke)
      call regrid(sal,salg,ke)
      call regrid(deptp,depthg,1)
      call regrid(orgprod,orgprodg,1)
      call regrid(calprod,calprodg,1)
      call regrid(sco212,sco212g,ke)
      call regrid(alkali,alkalig,ke)
      call regrid(phosph,phosphg,ke)
      call regrid(oxygen,oxygeng,ke)

      do k=1, ke
         do j=1, je
            do i=1, ie
               if( sco212(i,j,k) .GT. 0) then
                  call calc_dco3(tem(i,j,k),sal(i,j,k),
     $                 -100.*z_grid(k),
     $                 alkali(i,j,k),sco212(i,j,k),
     $                 co3(i,j,k),dco3(i,j,k),pco2(i,j,k))
                  call calc_dco3(tem(i,j,k),sal(i,j,k),
     $                 deptp(i,j)/100.,
     $                 alkali(i,j,k),sco212(i,j,k),
     $                 a_junk2,dco3bw(i,j),a_junk)
                  c14(i,j,k) = ( sco214(i,j,k)
     $                         / sco212(i,j,k)
     $                         - 1.d0 ) * 1000.d0
               else
                     co3(i,j,k) = 0.
                     dco3(i,j,k) = 0.
                     pco2(i,j,k) = 0.
               endif
            enddo
         enddo
      enddo
      
      call regrid(co3,co3g,ke)
      call regrid(dco3,dco3g,ke)
      call regrid(pco2,pco2g,ke)
      call regrid(c14,c14g,ke)
      call regrid(dco3bw,dco3bwg,1)

      do iS = 7, 14  ! Hg main species
         call regrid(ca(1,1,1,iS),ca_g(1,1,1,iS),ke)
      enddo
      call regrid(poc_inv,poc_invg,ke)
      call regrid(hg_2p_bound,hg_2p_boundg,ke)
      call regrid(hg_2p_sinking_flux,hg_2p_sinking_fluxg,ke)
      call regrid(hg_2p_particle_src,hg_2p_particle_srcg,ke)
      call regrid(hg_particle_lifetime,hg_particle_lifetimeg,ke)
      call regrid(hg_deposition,hg_depositiong,1)
      call regrid(hg_0_degassing,hg_0_degassingg,1)
      call regrid(hg_dm_degassing,hg_dm_degassingg,1)
      hg_surface_netg = hg_depositiong
     $     - hg_0_degassingg
     $     - hg_dm_degassingg
      call regrid(hg_2p_meth_rate,hg_2p_meth_rateg,ke)
      call regrid(hg_adv_surf_src,hg_adv_surf_srcg,1)
c      call regrid(hg_microb_demeth_rate,hg_microb_demeth_rateg,ke)
c      call regrid(hg_photo_demeth_rate,hg_photo_demeth_rateg,ke)

c#ifdef Hg_Isotopes
      hg_isotopes = -1.d-6
      
      do k=1, ke
         do j=1, je
            do i=1, ie
               if( hg_2p(i,j,k) .GT. 0.d0 ) then
                  do iS = 0, 3   ! hg_2p, hg_mm, etc
                     call calc_hg_deltas(
     $                 ca(i,j,k,11+iS),
     $                 ca(i,j,k,15+iS),
     $                 ca(i,j,k,19+iS),
     $                 ca(i,j,k,23+iS),
     $                 hg_isotopes(i,j,k,iS+1,1),   ! d199
     $                 hg_isotopes(i,j,k,iS+1,2),   ! d200
     $                 hg_isotopes(i,j,k,iS+1,3),   ! d202
     $                 hg_isotopes(i,j,k,iS+1,4),   ! capD199
     $                 hg_isotopes(i,j,k,iS+1,5) )  ! capD200
                  enddo
               endif
            enddo
         enddo
      enddo      
      do iS = 1, 4
         do iT = 1, 5
            call regrid( hg_isotopes(:,:,:,iS,iT),
     $                  hg_isotopes_g(:,:,:,iS,iT), ke)
         enddo
      enddo
c#endif

      do k=1, ke
         do j=1, j_out
            do i=1, i_out
               if(ca_g(i,j,k,10) .GT. 0.d0) then
                  hg_2p_bound_fracg(i,j,k) =
     $                   hg_2p_boundg(i,j,k)
     $                 / ca_g(i,j,k,10)
               endif
            enddo
         enddo
      enddo

c     scale the results to convenient units

      do i=1, i_out
         do j=1, j_out
            dco3bwg(i,j) = dco3bwg(i,j) * 1.E6
            depthg(i,j) = -depthg(i,j) / 10000.
            do k=1, ke
               pco2g(i,j,k) = pco2g(i,j,k) * 1.E6
               phosphg(i,j,k) = phosphg(i,j,k) * 1.E6 / 106.
               oxygeng(i,j,k) = oxygeng(i,j,k) * 1.E6
               alkalig(i,j,k) = alkalig(i,j,k) * 1.E6
               sco212g(i,j,k) = sco212g(i,j,k) * 1.E6
               dco3g(i,j,k) = dco3g(i,j,k) * 1.E6
               co3g(i,j,k) = co3g(i,j,k) * 1.E6
               if( depthg(i,j) .EQ. 0 ) then
                  alkalig(i,j,k) = -99.
                  sco212g(i,j,k) = -99.
                  dco3g(i,j,k) = -99.
                  dco3bwg(i,j) = -99.
               endif
c               hg_2pg(i,j,k) = hg_2pg(i,j,k)  ! picoM, 1-2
!                 at surface, 50% lower subsurface Pacific VERTEX Laurier

c               hg_mmg(i,j,k) = hg_mmg(i,j,k) * 1.d3 ! femtoM, 
!                compare to Hammerschmidt 2012 3 at surface 1 deep
            enddo
         enddo
      enddo
      ca_g(:,:,:,7:14) = ca_g(:,:,:,7:14) * 1.d12 ! pM
      
      idNC = nccre(filename,NCCLOB,rcode)
      
      idX = ncddef(idNC,'X',i_out,rcode)
      idY = ncddef(idNC,'Y',j_out,rcode)
      idZ = ncddef(idNC,'Z',ke,rcode)
      
      idX = ncvdef(idNC,'X',NCFLOAT,1,1,rcode)
      idY = ncvdef(idNC,'Y',NCFLOAT,1,2,rcode)
      idZ = ncvdef(idNC,'Z',NCFLOAT,1,3,rcode)

      do iS = 1, 4
         hg_indices(iS) = ncvdef(idNC,hg_names(iS),
     $        NCFLOAT,3,vdims,rcode)
      enddo
      idhg_tot = ncvdef(idNC,'hg_tot',
     $     NCFLOAT,3,vdims,rcode)
c      idhg_mm = ncvdef(idNC,'Hg_Mm',
c     $     NCFLOAT,3,vdims,rcode)
      idPOC_inv = ncvdef(idNC,'POC',
     $     NCFLOAT,3,vdims,rcode)
      idHgbndfrc = ncvdef(idNC,'Hg_Bound_Frac',
     $     NCFLOAT,3,vdims,rcode)
      idHgsinkTau = ncvdef(idNC,'Hg_Sink_Tau',
     $     NCFLOAT,3,vdims,rcode)
      idHgsinkFlux = ncvdef(idNC,'Hg_Sink_Flux',
     $     NCFLOAT,3,vdims,rcode)
      idHgsinkSrc = ncvdef(idNC,'Hg_Sink_Src',
     $     NCFLOAT,3,vdims,rcode)
      idHgDep = ncvdef(idNC,'Hg_Dep',
     $     NCFLOAT,2,vdims,rcode)
      idHg0Evp = ncvdef(idNC,'Hg_0_Evp',
     $     NCFLOAT,2,vdims,rcode)
      idHgDmEvp = ncvdef(idNC,'Hg_dm_Evp',
     $     NCFLOAT,2,vdims,rcode)
      idHgSurfNet = ncvdef(idNC,'Hg_Surf_Net',
     $     NCFLOAT,2,vdims,rcode)
      idhg_mm_rate = ncvdef(idNC,'Hg_Mm_rate',
     $     NCFLOAT,3,vdims,rcode)
      idHg_microb_demeth_rate = ncvdef(idNC,'Hg_Micro_Demeth_rate',
     $     NCFLOAT,3,vdims,rcode)
      idHg_photo_demeth_rate = ncvdef(idNC,'Hg_Photo_Demeth_rate',
     $     NCFLOAT,3,vdims,rcode)
      idHg_adv_surf_src = ncvdef(idNC,'Hg_Adv_Surf_Src',
     $     NCFLOAT,3,vdims,rcode)
      do iS = 1, 4
         do iIsotope = 1, 5
            hg_isotope_name = trim(hg_names(iS))//'_'//
     $           trim(isotope_names(iIsotope))

            hg_isotope_indices(iS,iIsotope) = ncvdef(idNC,
     $           hg_isotope_name,
     $           NCFLOAT,3,vdims,rcode)
         enddo
      enddo
c      idhg_2p_d199 = ncvdef(idNC,'hg_2p_d199',
c     $     NCFLOAT,3,vdims,rcode)
c      idhg_2p_d202 = ncvdef(idNC,'hg_2p_d202',
c     $     NCFLOAT,3,vdims,rcode)
c      idhg_2p_capD199 = ncvdef(idNC,'hg_2p_capD199',
c     $     NCFLOAT,3,vdims,rcode)
c      idhg_mm_d199 = ncvdef(idNC,'hg_mm_d199',
c     $     NCFLOAT,3,vdims,rcode)
c      idhg_mm_d202 = ncvdef(idNC,'hg_mm_d202',
c     $     NCFLOAT,3,vdims,rcode)
c      idhg_mm_capD199 = ncvdef(idNC,'hg_mm_capD199',
c     $     NCFLOAT,3,vdims,rcode)

      idPCO2 = ncvdef(idNC,'pCO2',NCFLOAT,3,vdims,rcode)
      idPO4 = ncvdef(idNC,'PO4',NCFLOAT,3,vdims,rcode)
      idO2 = ncvdef(idNC,'O2',NCFLOAT,3,vdims,rcode)
      idTC = ncvdef(idNC,'TCO2',NCFLOAT,3,vdims,rcode)
      idAL = ncvdef(idNC,'Alky',NCFLOAT,3,vdims,rcode)
      idCO3 = ncvdef(idNC,'CO3',NCFLOAT,3,vdims,rcode)
      idDCO3 = ncvdef(idNC,'DCO3',NCFLOAT,3,vdims,rcode)
      idC14 = ncvdef(idNC,'C14',NCFLOAT,3,vdims,rcode)
      idOProd = ncvdef(idNC,'OProd',NCFLOAT,2,vdims,rcode)
      idCProd = ncvdef(idNC,'CProd',NCFLOAT,2,vdims,rcode)
      idCaCO3 = ncvdef(idNC,'CaCO3',NCFLOAT,2,vdims,rcode)
      idDCBW = ncvdef(idNC,'DCO3BW',NCFLOAT,2,vdims,rcode)
      
      call ncendf(idNC,rcode)
      
      call ncvpt(idNC,idX, 1, 144, x_grid, rcode)
      call ncvpt(idNC,idY, 1, 72, y_grid, rcode)
      call ncvpt(idNC,idZ, 1, 11, z_grid, rcode)
      
      do iS = 1, 4
         call ncvpt(idNC,hg_indices(iS), start, count,
     $        ca_g(1,1,1,10+iS), rcode)
      enddo
      call ncvpt(idNC,idhg_tot, start, count, ca_g(1,1,1,7), rcode)
c      call ncvpt(idNC,idhg_mm, start, count, hg_mmg, rcode)

      call ncvpt(idNC,idPOC_inv, start, count, poc_invg, rcode)
      call ncvpt(idNC,idHgbndfrc, start, count, hg_2p_bound_fracg,
     $     rcode)
      call ncvpt(idNC,idHgsinkflux, start, count, hg_2p_sinking_fluxg,
     $     rcode)
      call ncvpt(idNC,idHgsinktau, start, count, hg_particle_lifetimeg,
     $     rcode)
      call ncvpt(idNC,idHgsinksrc, start, count, hg_particle_srcg,
     $     rcode)
      call ncvpt(idNC,idHgDep, start, count, hg_depositiong,
     $     rcode)
      call ncvpt(idNC,idHg0Evp, start, count, hg_0_degassingg,
     $     rcode)
      call ncvpt(idNC,idHgDmEvp, start, count, hg_dm_degassingg,
     $     rcode)
      call ncvpt(idNC,idHgSurfNet, start, count, hg_surface_netg,
     $     rcode)
      call ncvpt(idNC,idHg_adv_surf_src, start, count, hg_adv_surf_srcg,
     $     rcode)
      call ncvpt(idNC,idhg_mm_rate, start, count,
     $     hg_2p_meth_rateg, rcode)
      call ncvpt(idNC,idHg_microb_demeth_rate, start, count,
     $     hg_microb_demeth_rateg, rcode)
      call ncvpt(idNC,idHg_photo_demeth_rate, start, count,
     $     hg_photo_demeth_rateg, rcode)
      do iS = 1, 4
         do iIsotope = 1, 5
            call ncvpt(idNC,hg_isotope_indices(iS,iIsotope),
     $           start, count, hg_isotopes_g(1,1,1,iS,iIsotope),
     $           rcode)
         enddo
      enddo

c      call ncvpt(idNC,idhg_2p_d199, start, count, hg_2p_d199g,
c     $     rcode)
c      call ncvpt(idNC,idhg_2p_d202, start, count, hg_2p_d202g,
c     $     rcode)
c      call ncvpt(idNC,idhg_2p_capD199, start, count,
c     $     hg_2p_capD199g,
c     $     rcode)
c      call ncvpt(idNC,idhg_mm_d199, start, count, hg_mm_d199g,
c     $     rcode)
c      call ncvpt(idNC,idhg_mm_d202, start, count, hg_mm_d202g,
c     $     rcode)
c      call ncvpt(idNC,idhg_mm_capD199, start, count,
c     $     hg_mm_capD199g,
c     $     rcode)
c      call ncvpt(idNC,idHg_0_d199, start, count, hg_0_d199g,
c     $     rcode)
c      call ncvpt(idNC,idHg_0_d202, start, count, hg_0_d202g,
c     $     rcode)
c      call ncvpt(idNC,idHg_0_capD199, start, count,
c     $     hg_0_capD199g,
c     $     rcode)

      call ncvpt(idNC,idPCO2, start, count, pco2g, rcode)
      call ncvpt(idNC,idPO4, start, count, phosphg, rcode)
      call ncvpt(idNC,idO2, start, count, oxygeng, rcode)
      call ncvpt(idNC,idTC, start, count, sco212g, rcode)
      call ncvpt(idNC,idAL, start, count, alkalig, rcode)
      call ncvpt(idNC,idCO3, start, count, co3g, rcode)
      call ncvpt(idNC,idDCO3, start, count, dco3g, rcode)
      call ncvpt(idNC,idC14, start, count, c14g, rcode)
      call ncvpt(idNC,idOProd, start, count, orgprodg, rcode)
      call ncvpt(idNC,idCProd, start, count, calprodg, rcode)
      call ncvpt(idNC,idCaCO3, start, count, calpct_g, rcode)
      call ncvpt(idNC,idDCBW, start, count, dco3bwg, rcode)
      
      call ncclos(idNC,rcode)

c      call gzip(filename)  
      
c      WRITE(6,*) nyear
      
c     WRITE(99)nyear,
c     $        sco212,alkali,
c     $        c_advect,ttrcal,calpct
      
      RETURN
      END


      subroutine ip2grid(pfield, gfield,map_x,map_y,map_z,i_parallel)

      PARAMETER(ie=72,je=76,ke=11)
      PARAMETER(i_out=144,j_out=72)
      PARAMETER(ip_sedmain_max=2600)

      real pfield(ip_sedmain_max), efield(ie,je)
      real*4 gfield(i_out,j_out)
      integer map_x(ip_sedmain_max),map_y(ip_sedmain_max),
     $     map_z(ip_sedmain_max)
      
c     convert from sediment parallel scheme to xy ernie grid
      do ix = 1, ie
         do iy=1, je
            efield(ix,iy) = 0.
         enddo
      enddo
      DO ip = 1, i_parallel
         efield(map_x(ip),map_y(ip)) = pfield(ip)
      enddo

      call regrid(efield,gfield,1)

      return
      end


      subroutine ip3d2grid(pfield, gfield,map_x,map_y,map_z,i_parallel)

      include 'parameter.sediment.include'
      PARAMETER(ie=72,je=76,ke=11)
      PARAMETER(i_out=144,j_out=72)
c      PARAMETER(ip_sedmain_max=2600)

      real pfield(i_bur_rec_max,ip_sedmain_max),
     $     efield(ie,je,i_bur_rec_max)
      real*4 gfield(i_out,j_out,i_bur_rec_max)
      integer map_x(ip_sedmain_max),map_y(ip_sedmain_max),
     $     map_z(ip_sedmain_max)
      
c     convert from sediment parallel scheme to xy ernie grid
      do ix = 1, ie
         do iy=1, je
            do iz=1, i_bur_rec_max
               efield(ix,iy,iz) = 0.
            enddo
         enddo
      enddo
      DO ip = 1, i_parallel
         do iz=1, i_bur_rec_max
            efield(map_x(ip),map_y(ip),iz) = pfield(iz,ip)
         enddo
      enddo

      call regrid(efield,gfield,i_bur_rec_max)

      return
      end



      SUBROUTINE regrid(efield, gfield, nk)

      PARAMETER(ie=72,je=76,ke=20)

      PARAMETER(i_out=144,j_out=72)

      REAL*4 lat,longt

      REAL efield(ie,je,ke)
      real*4 gfield(i_out,j_out,ke)
      integer n(i_out,j_out,ke)

      a_missing_data = -1.d-6

c     initialized arrays with missing data values
      DO 5 k = 1, nk
         DO 5 i = 1, i_out
            DO 5 j = 1, j_out
               gfield(i,j,k) = a_missing_data
    5 CONTINUE

c     convert from EMR tilted grid to xy grid -- only half filled
      DO 10 k = 1, nk
         DO 10 j = 3,74
            DO 10 i = 1, ie
c               if( i .EQ. 9 .AND. j .EQ. 20 ) then
c                  write(6,*) "fuck"
c               endif
               lat = 88.75 - (j-3)*2.5
               longt = MOD( (i-1)*5. - (j-3)*2.5 + 360., 360.)
               ix =  MOD( 2*(i-1) - (j-3) + 144, 144) + 1
               iy = 73 - j + 3 - 1
               gfield(ix,iy,k) = efield(i,j,k)
   10 CONTINUE

      DO 20 k = 1, nk
         DO 20 j = 1, j_out
            DO 20 i = 1, i_out-1, 2
               i_offset = MOD(j-1,2)
c               write(6,*) i,j,i_offset
c               if( j .EQ. 20 .AND. i_fill .EQ. 9 ) then
c                  write(6,*) "fuck!"
c               endif
               i_fill = MOD(i+i_offset+144-1,144) + 1
               i_left = MOD(i_fill-2+144,144) + 1
               i_right = MOD(i_fill+144,144) + 1
               i_top = i_fill
               i_bottom = i_fill

               gfield(i_fill,j,k) = 0.
               n(i_fill,j,k) = 0
               if( gfield(i_left,j,k) .NE. a_missing_data ) then
                  gfield(i_fill,j,k) = gfield(i_fill,j,k)
     $                               + gfield(i_left,j,k)
                  n(i_fill,j,k) = n(i_fill,j,k)+1
               endif
c               if( gfield(i_right,j,k) .NE. a_missing_data ) then
c                  gfield(i_fill,j,k) = gfield(i_fill,j,k)
c     $                               + gfield(i_right,j,k)
c                  n(i_fill,j,k) = n(i_fill,j,k)+1
c               endif
c               if( gfield(i_top,j-1,k) .NE. a_missing_data ) then
c                  gfield(i_fill,j,k) = gfield(i_fill,j,k)
c     $                               + gfield(i_top,j-1,k)
c                  n=n+1
c               endif
c               if( gfield(i_bottom,j+1,k) .NE. a_missing_data ) then
c                  gfield(i_fill,j,k) = gfield(i_fill,j,k)
c     $                               + gfield(i_bottom,j+1,k)
c                  n=n+1
c               endif
               
               if( n(i_fill,j,k) .GT. 0 ) then
                  gfield(i_fill,j,k) = gfield(i_fill,j,k)
     $                 / n(i_fill,j,k)
               else
                  gfield(i_fill,j,k) = a_missing_data
               endif

c               if( k .EQ. 1) then
c                  write(6,*) i_fill,gfield(i_fill,j,k), n
c               endif

c               IF( ( gfield(i_left,j,k) .NE. a_missing_data )
c     *              .AND.
c     *             ( gfield(i_right,j,k) .NE. a_missing_data )
c     *              .AND.
c     *             ( gfield(i_top,j,k) .NE. a_missing_data )
c     *              .AND.
c     *             ( gfield(i_bottom,j,k) .NE. a_missing_data )
c     *           ) THEN
c                  gfield(i_fill,j,k) = (
c     $                   gfield(i_left,j,k)
c     *                 + gfield(i_right,j,k)
c     *                 + gfield(i_top,j,k)
c     *                 + gfield(i_bottom,j,k)
c     $                                ) /2
c               ENDIF

   20 CONTINUE
                 
      RETURN
      END



      SUBROUTINE calc_dco3(temp,sal,z,alk,tco2,co3,dco3,pco2)

      REAL KW, IS, KHCO2, NU, KWO2, KWAR, KWCO2
      REAL K1, K2, KB, HP, HYDX, PCO2, PAIR, KPRIME, KPRES

c      DO 100 LOOP = 1,1000
c        READ (5,*,END=20) TEMP,SAL,Z,ALK,TCO2
C                         C o/oo   m uM   uM
C
C     Calculate {H2CO3*}, from alk and tco2
C 
C       k1 and k2 (apparent), from mehrbach

      if (tco2 .LE. 0) then
         dco3 = -99.
         pco2 = -99.
         return
      endif

          tk = temp + 273.15

          k1 = 13.7201 - 0.031334 * tk
     *       - 3235.76 / tk
     *       - 1.3E-5 * sal * tk
     *       + 0.1032 * sal**(0.5)

          k1 = 10**(k1)
          cp = (z/10.) / 83.143 / tk
          prat = ( 24.2 - 0.085 * temp )
     *           * cp
          prat = exp(prat)
          k1 = k1 * prat
           
          k2 = - 5371.9645
     *         - 1.671221 * tk
     *         + 128375.28 / tk
     *         + 2194.3055 * LOG10( tk )
     *         - 0.22913 * sal
     *         - 18.3802 * LOG10( sal )
     *         + 8.0944E-4 * sal * tk
     *         + 5617.11 * LOG10( sal ) / tk
     *         - 2.136 * sal / tk

          k2 = 10**(k2)
          prat = (16.4 - 0.04*temp)
     *           * cp
          prat = exp(prat)
          k2 = k2 * prat

C    lyman's kb
          kb = 2291.9/(temp+273)
     .           + 0.01756 * (temp+273)
     .           - 3.385
     .           - .32051 * (sal/1.80655)**(1./3.)
          kb = 10**(-kb)
          prat = (27.5 - 0.095*temp)
     *           * cp
          prat = exp(prat)
          kb = kb * prat

C       to mol/l
      CALL NEWT(ALK,TCO2,SAL,TEMP,
     1          K1,K2,KB,CO2,HCO3,CO3)
C
C      Saturation of CO2, from Edmond and Geiskes (Stumm and Morgan p 204)
         IS = 0.00147 + .03592 * SAL/2 + .000068 * (SAL/2)**2
         KHCO2 = - 2385.73 / (TEMP + 273.15)
     1           + 14.0184
     2           - 0.0152642 * (TEMP + 273.15)
     3           + IS * (0.28596 - 6.167E-4 * (TEMP + 273.15) )
C        Kh = { HCO3* } / pCO2
       KHCO2 = 10**( - KHCO2)
C        calculate SS pCO2
       PCO2 = CO2 / KHCO2

       KPRIME = 4.75E-7
C                mol2 / kg2
       DELV = -44
C                cm3 / mol
       RR = 83.14
C                cm3 bar / K mol
       PRES = Z/10
C                bar
       DK = -.0133
C                cm3 / bar mol
       KPRES = LOG(10.0)
       KPRES = LOG(KPRIME)
     *           - DELV / (RR * (TEMP + 273) ) * (PRES)
     *           + 0.5 * DK / (RR * (TEMP + 273) ) * (PRES)**2
       KPRES = EXP(KPRES)

       CSAT = KPRES / 0.01

       dco3 = co3 - csat

c       IF( z .GT. 4000 ) THEN
c          WRITE(6,10) z,ALK,TCO2,CO3*1e6,CSAT*1e6,dco3*1e6
c       endif
C                 C        uM  uM   atm  pH             uM  uM
   10   FORMAT(1X,6G11.4)

c  100   CONTINUE
c   20   CONTINUE

      RETURN
      END

      SUBROUTINE NEWT(ALK,TCO2,SAL,TEMP,K1,K2,KB,
     *      CO2,HCO3,CO3)
      REAL K1,K2,KB
      TBOR = 4.106E-4*SAL/35.
      TKT = TEMP+273
      TK = TKT/100.

      C1 = K1/2.0
      C2 = 1.0-4.0*K2/K1
      C4 = TBOR*KB
      AHT= 0.74E-8

      DO 100 ICNT=1,100
        A = ALK-C4/(KB+AHT)
        X = A/TCO2
        AH1 = C1/X*(1.0-X+SQRT(1.0+C2*X*(-2.+X)))
        IF(0.5E-4.GE.ABS(1.-AHT/AH1)) GOTO 200
        AHT=AH1
  100 CONTINUE
  200 CONTINUE

      CO3 = (A-TCO2)/(1.0-(AH1*AH1)/(K1*K2))
      HCO3 = TCO2/(1.+AH1/K1+K2/AH1)
      CO2 = TCO2/(1.0+K1/AH1+K1*K2/(AH1*AH1))

      RETURN
      END



      SUBROUTINE intermed(nyear,nyetot,n_output_rotation)
      INCLUDE 'parameter.include'
      INCLUDE 'parameter.sediment.include'
      INCLUDE 'common.horvel'
      INCLUDE 'common.wathic'
      INCLUDE 'common.chemis'
      INCLUDE 'common.biocon'
      INCLUDE 'common.topogr'
      INCLUDE 'common.production'
      INCLUDE 'common.thermo'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.divers'
      INCLUDE 'common.caco3c' 
      INCLUDE 'common.seddiag'
      include 'common.sediment'
      INCLUDE 'equivalence.include'
      character*14 outstring

      return

      outstring = 'intermed.00000'
      nstp = nyear
      do ipos=14,10,-1
         idigit = mod(nstp,10)
         outstring(ipos:ipos) = char(ichar('0') + idigit)
         nstp = nstp/10
      enddo

      OPEN(107,file=outstring,status='unknown',
     .     access='sequential',form='unformatted')
      WRITE(107) nyear,nyetot,atqqq,c12inv,c13inv,c14inv,phoinv,alkinv,
     .        atc,chemv,ca,cn,prorca,
     *        calgg,buried_mass,buried_calfrac,
     $        pore,form,o2,carb,orgml,calml,dissfrc
      close(107)

      return
      end

      
      SUBROUTINE intermed2(nyear,nyetot,n_output_rotation)
      INCLUDE 'parameter.include'
      INCLUDE 'parameter.sediment.include'
      INCLUDE 'common.horvel'
      INCLUDE 'common.wathic'
      INCLUDE 'common.chemis'
      INCLUDE 'common.biocon'
      INCLUDE 'common.topogr'
      INCLUDE 'common.production'
      INCLUDE 'common.thermo'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.divers'
      INCLUDE 'common.caco3c' 
      INCLUDE 'common.seddiag'
      INCLUDE 'equivalence.include'
      character*14 mssstring

      IF(n_output_rotation .EQ. 1) THEN
         REWIND(97)
         WRITE(97)nyear,nyetot,atqqq,c12inv,c13inv,c14inv,phoinv,alkinv,
     .        atc,chemv,ca,cn,prorca,
     *        calgg,buried_mass,buried_calfrac
         n_output_rotation = 2
         mssstring = "intermed.00000"
         nstp = nyear
         do ipos=14,10,-1
            idigit = mod(nstp,10)
            mssstring(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp/10
         enddo
c         CALL mswrite(ierr, "CC.INTERMED.A", outstring, " ", " ")
      ELSE
         REWIND(98)
         WRITE(98)nyear,nyetot,atqqq,c12inv,c13inv,c14inv,phoinv,alkinv,
     .        atc,chemv,ca,cn,prorca,
     *        calgg,buried_mass,buried_calfrac
         n_output_rotation = 1
         mssstring = "intermed.00000"
         nstp = nyear
         do ipos=14,10,-1
            idigit = mod(nstp,10)
            mssstring(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp/10
         enddo
c         CALL mswrite(ierr, "CC.INTERMED.B", outstring, " ", " ")
C         outstring = "mswrite intermed.00000.tar    "
C         nstp = nyear
C         do ipos=22,18,-1
C            idigit = mod(nstp,10)
C            outstring(ipos:ipos) = char(ichar('0') + idigit)
C            nstp = nstp/10
C         enddo
C         CALL system(outstring)
      ENDIF

      RETURN
      END

      subroutine gzip(filename)

      character*25 filename
      character*35 syscallstring

c     compress velocity file
      write(syscallstring,105) "gzip -f ", filename
 105  format(A8,A25)
      write(6,*) syscallstring
      call system(syscallstring)

      return
      end

