
      SUBROUTINE estimate_rc(rain_org,rc,i_parallel)
      REAL rain_org(i_parallel),rc(i_parallel)
      DO 10 ip = 1, i_parallel
        rc(ip) = 2.E-9
 10   CONTINUE
      RETURN
      END

      SUBROUTINE setup_pw(co2,hco3,co3,o2_bw,
     .               carb,o2,csat,
     .               kmax,i_parallel,ip_sedmain_max,nz_sedmain_max)
      REAL co2(i_parallel),hco3(i_parallel),co3(i_parallel)
      REAL o2_bw(i_parallel)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL o2(nz_sedmain_max,ip_sedmain_max)
      REAL csat(ip_sedmain_max)

CDIR$ NOVECTOR

c      DO 20 k = 2, kmax
c      DO 20 ip = 1, i_parallel
c        o2(1,ip) = o2_bw(ip)
c        carb(k,1,ip) = co2(ip)
c        carb(k,2,ip) = hco3(ip)
c        carb(k,3,ip) = csat(ip) - 15.E-6
c 20   CONTINUE
      DO 10 ip = 1, i_parallel
        o2(1,ip) = o2_bw(ip)
        carb(1,1,ip) = co2(ip)
        carb(1,2,ip) = hco3(ip)
        carb(1,3,ip) = co3(ip)
c        carb(2,3,ip) = (2 * co3(ip) + csat(ip)) / 3
c        carb(3,3,ip) = (co3(ip) + 2 * csat(ip)) / 3
10    CONTINUE

      RETURN
      END

      SUBROUTINE reset_pw(carb,csat,
     .               kmax,
     *               ip,
     *               ip_sedmain_max,nz_sedmain_max)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL csat(ip_sedmain_max)

CDIR$ NOVECTOR

      carb(2,3,ip) = ( 2 * carb(1,3,ip)
     *                 + (csat(ip)-15.E-6)
     *               ) / 3
      carb(3,3,ip) = ( carb(1,3,ip)
     *                 + 2 * (csat(ip)-15.E-6)
     *               ) / 3

      DO 20 k = 4, kmax
        carb(k,3,ip) = csat(ip) - 10.E-6
 20   CONTINUE

      DO 30 k = 2, kmax
         carb(k,1,ip) = carb(1,1,ip)
         carb(k,2,ip) = carb(1,2,ip)
   30 CONTINUE

c      WRITE(6,*) 'Emergency pw Reset'

      RETURN
      END
      

      SUBROUTINE init_stuff(kmax,
     *              zsed,delz,pore,form,
     .              o2,carb,zrct,
     *              orggg,orgml,calgg,calml,
     *              dopls,domin,dcpls,dcmin,dbpls,dbmin,
     *              i_parallel,ip_sedmain_max,nz_sedmain_max)

      PARAMETER( nz_local_max = 10)

c   external variables
      REAL zsed(nz_sedmain_max),delz(nz_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL o2(nz_sedmain_max,ip_sedmain_max),zrct(i_parallel)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL orggg(nz_sedmain_max,ip_sedmain_max)
      REAL orgml(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL dopls(nz_sedmain_max,ip_sedmain_max)
      REAL domin(nz_sedmain_max,ip_sedmain_max)
      REAL dcpls(nz_sedmain_max,3,ip_sedmain_max)
      REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)
      REAL dbpls(nz_sedmain_max,ip_sedmain_max)
      REAL dbmin(nz_sedmain_max,ip_sedmain_max)
      REAL difo2, difc(3)

c   internal variables
      REAL delz_init(nz_local_max), pore_init(nz_local_max)

      DATA delz_init /0.,.5,.5,1.,2.,5*3./

CDIR$ NOVECTOR

      DO 50 j = 1, nz_sedmain_max
         delz(j) = delz_init(j)
   50 CONTINUE

      kmax = 7
      expb = 3.0
      difo2 = 12.1e-6
      difc(1) = 10.5e-6
      difc(2) = 6.4e-6
      difc(3) = 5.2e-6 
      db = 0.15

      DO 10 k=2, kmax
         zsed(1) = 0.
         zsed(k) = zsed(k-1) + delz(k)
   10  CONTINUE

      DO 20 k = 1, kmax
      DO 20 ip = 1, i_parallel
        orggg(k,ip) = 0.0002
        calgg(k,ip) = 0.1
        o2(k,ip) = 150.E-6
        carb(k,1,ip) = 20.E-6
        carb(k,2,ip) = 2000.E-6
        carb(k,3,ip) = 80.E-6
        zrct(ip) = zsed(kmax)
 20   CONTINUE

      CALL set_pore(calgg,zsed,pore,
     *              kmax,i_parallel,ip_sedmain_max,nz_sedmain_max)

      CALL pore_2_form(pore,form,kmax,3.0,
     .        i_parallel,ip_sedmain_max,nz_sedmain_max)

      CALL sldcon(orgml,orggg,12.,pore,kmax,
     .            i_parallel,ip_sedmain_max,nz_sedmain_max)
      CALL sldcon(calml,calgg,100.,pore,kmax,
     .            i_parallel,ip_sedmain_max,nz_sedmain_max)

      CALL calc_do2(difo2,
     *      form,pore,delz,kmax,
     *      dopls,domin,i_parallel,ip_sedmain_max,nz_sedmain_max)
      CALL calc_dc(difc,form,pore,delz,kmax,
     .            dcpls,dcmin,
     .            i_parallel,ip_sedmain_max,nz_sedmain_max)
      CALL calc_db(db,
     .             pore,zsed,delz,kmax,
     .             dbpls,dbmin,
     .             i_parallel,ip_sedmain_max,nz_sedmain_max)

      RETURN
      END

c  finds the steady state calcite concentration in the sediments	
      SUBROUTINE sed_ss(zsed,delz,form,pore,kmax,
     *     o2,zrct,carb,	
     *     orgml,orggg,calml,calgg,	
     *     raincal,rainorg,rainclay,	
     *     r13or,r14or,r13ca,r14ca,	
     *     rc,dissc,dissn,csat,u1,u2,	
     *     dopls,domin,dcpls,dcmin,dbpls,dbmin,
     *     resp_c,cal_c,
     *     ttrorg,ttrcal,
     *     ttrtc,ttral,
     *     diftc,difal,
     *     c_advect,
     *     buried_mass,buried_calfrac,n_buried_depths,
     .     i_parallel,ip_sedmain_max,nz_sedmain_max,
     *     i_bur_rec_max,
     *     n_control)	

c   arguments
      REAL zsed(nz_sedmain_max),delz(nz_sedmain_max)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL o2(nz_sedmain_max,ip_sedmain_max), zrct(i_parallel)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL orgml(nz_sedmain_max,ip_sedmain_max)
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL orggg(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      REAL raincal(i_parallel),rainorg(i_parallel)
      REAL rainclay(i_parallel)
      REAL r13or,r14or,r13ca,r14ca
      REAL rc(i_parallel), dissc, dissn, csat(i_parallel)
      REAL u1(i_parallel), u2(i_parallel)
      REAL dopls(nz_sedmain_max,ip_sedmain_max)
      REAL domin(nz_sedmain_max,ip_sedmain_max)
      REAL dcpls(nz_sedmain_max,3,ip_sedmain_max)
      REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)
      REAL dbpls(nz_sedmain_max,ip_sedmain_max)
      REAL dbmin(nz_sedmain_max,ip_sedmain_max)
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
      REAL cal_c(nz_sedmain_max,ip_sedmain_max)
      REAL difo2, difc(3)

c   results
      REAL ttrorg(i_parallel),ttrcal(i_parallel)
      REAL ttrtc(i_parallel),ttral(i_parallel)
      REAL difal(i_parallel),diftc(i_parallel)
      REAL c_advect(i_parallel)
      REAL buried_mass(i_bur_rec_max,ip_sedmain_max)
      REAL buried_calfrac(i_bur_rec_max,ip_sedmain_max)
      INTEGER n_buried_depths(ip_sedmain_max)
CDIR$ NOVECTOR

      CALL o2org(rainorg,rc,kmax,
     *     zsed,delz,form,pore,
     .     dopls,domin,dbpls,dbmin,
     *     o2,zrct,
     *     orgml,orggg,
     *     resp_c,
     .     i_parallel,ip_sedmain_max,nz_sedmain_max,
     *     n_control)

      CALL calss(raincal,rainorg,rainclay,
     .           resp_c,cal_c,
     .           dissc,dissn,csat,u1,u2,
     .           dcpls,dcmin,
     .           zsed,delz,form,pore,kmax,
     .           calml,calgg,carb,
     *           ttrorg,ttrcal,ttral,ttrtc,difal,diftc,c_advect,
     .           i_parallel,ip_sedmain_max,
     .           nz_sedmain_max,
     *           n_control)

      expb = 3.0
      difo2 = 12.1e-6
      difc(1) = 10.5e-6
      difc(2) = 6.4e-6
      difc(3) = 5.2e-6 
      db = 0.15

         CALL set_pore(calgg,zsed,pore,
     *              kmax,i_parallel,ip_sedmain_max,nz_sedmain_max)
 
         CALL pore_2_form(pore,form,kmax,expb,
     .        i_parallel,ip_sedmain_max,nz_sedmain_max)

         CALL calc_do2(difo2,
     *        form,pore,delz,kmax,
     *        dopls,domin,i_parallel,ip_sedmain_max,nz_sedmain_max)
         CALL calc_dc(difc,form,pore,delz,kmax,
     .        dcpls,dcmin,
     .        i_parallel,ip_sedmain_max,nz_sedmain_max)
         CALL calc_db(db,
     .        pore,zsed,delz,kmax,
     .        dbpls,dbmin,
     .        i_parallel,ip_sedmain_max,nz_sedmain_max)

      CALL o2org(rainorg,rc,kmax,
     *     zsed,delz,form,pore,
     .     dopls,domin,dbpls,dbmin,
     *     o2,zrct,
     *     orgml,orggg,
     *     resp_c,
     .     i_parallel,ip_sedmain_max,nz_sedmain_max,
     *     n_control)

      CALL calss(raincal,rainorg,rainclay,
     .           resp_c,cal_c,
     .           dissc,dissn,csat,u1,u2,
     .           dcpls,dcmin,
     .           zsed,delz,form,pore,kmax,
     .           calml,calgg,carb,
     *           ttrorg,ttrcal,ttral,ttrtc,difal,diftc,c_advect,
     .           i_parallel,ip_sedmain_max,
     .           nz_sedmain_max,
     *           n_control)

      RETURN
      END

c  finds the steady state pore water chemistry with const calcite
      SUBROUTINE sed_const_cal(zsed,delz,form,pore,kmax,
     *     o2,zrct,carb,	
     *     orgml,orggg,calml,calgg,	
     *     raincal,rainorg,rainclay,	
     *     r13or,r14or,r13ca,r14ca,	
     *     rc,dissc,dissn,csat,u1,u2,	
     *     dopls,domin,dcpls,dcmin,dbpls,dbmin,
     *     resp_c,cal_c,
     *     ttrorg,ttrcal,
     *     ttrtc,ttral,
     *     diftc,difal,
     *     c_advect,
     .     i_parallel,ip_sedmain_max,nz_sedmain_max,
     *     n_control)	

c      include 'common.seddebug'

      PARAMETER(ip_sedcc_max = 2600)

c   arguments
      REAL zsed(nz_sedmain_max),delz(nz_sedmain_max)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL o2(nz_sedmain_max,ip_sedmain_max), zrct(i_parallel)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL orgml(nz_sedmain_max,ip_sedmain_max)
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL orggg(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      REAL raincal(i_parallel),rainorg(i_parallel)
      REAL rainclay(i_parallel)
      REAL r13or,r14or,r13ca,r14ca
      REAL rc(i_parallel), dissc, dissn, csat(i_parallel)
      REAL u1(i_parallel), u2(i_parallel)
      REAL dopls(nz_sedmain_max,ip_sedmain_max)
      REAL domin(nz_sedmain_max,ip_sedmain_max)
      REAL dcpls(nz_sedmain_max,3,ip_sedmain_max)
      REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)
      REAL dbpls(nz_sedmain_max,ip_sedmain_max)
      REAL dbmin(nz_sedmain_max,ip_sedmain_max)
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
      REAL cal_c(nz_sedmain_max,ip_sedmain_max)

c   results
      REAL ttrorg(i_parallel),ttrcal(i_parallel)
      REAL ttrtc(i_parallel),ttral(i_parallel)
      REAL difal(i_parallel),diftc(i_parallel)
      REAL c_advect(i_parallel)

c   internal variables
      INTEGER still_wrong(ip_sedcc_max), sum_wrong

CDIR$ NOVECTOR

      write(6,*) "going into o2org"
      CALL o2org(rainorg,rc,kmax,
     *     zsed,delz,form,pore,
     .     dopls,domin,dbpls,dbmin,
     *     o2,zrct,
     *     orgml,orggg,
     *     resp_c,
     .     i_parallel,ip_sedmain_max,nz_sedmain_max,
     *     n_control)

      DO 150 ip = 1, i_parallel
         still_wrong(ip) = ip
  150 CONTINUE
      sum_wrong = i_parallel

      inner_loop_limit = 50
      CALL co3ss(resp_c,cal_c,
     .     dissc,dissn,csat,
     *     u1,u2,
     .     zsed,delz,form,pore,kmax,
     .     dcpls,dcmin,
     .     calml,calgg,carb,
     *     ttrorg,ttrcal,ttral,ttrtc,difal,diftc,
     .     i_parallel,ip_sedmain_max,
     .     nz_sedmain_max,inner_loop_limit,
     *     still_wrong,sum_wrong,ip_sedcc_max)

       DO 50 ip = 1, i_parallel
          IF(
     *        ( ttrcal(ip) .GT. raincal(ip) ) .AND.
     *        ( calgg(kmax,ip) .LT. 0.001 )
     *      ) THEN
             ttrcal(ip) = raincal(ip)
          ENDIF
          c_advect(ip) = raincal(ip) - ttrcal(ip)
   50  CONTINUE

      RETURN
      END


      SUBROUTINE calc_k(temp,sal,z,k1,k2,kb,csat,
     *                  i_parallel)


      PARAMETER(ip_local_max = 2600)

      PARAMETER(kprime = 4.75e-7)
C                mol2 / kg2
      PARAMETER(delv = -44.)
C                cm3 / mol
      PARAMETER(rr = 83.14)
C                cm3 bar / k mol
      PARAMETER(dk = -.0133)
C                cm3 / bar mol

c   arguments
      REAL temp(i_parallel),sal(i_parallel),z(i_parallel)
      REAL k1(i_parallel),k2(i_parallel),kb(i_parallel),csat(i_parallel)

c   local variables
      REAL tk(ip_local_max),cp(ip_local_max)
      REAL prat(ip_local_max)
      REAL pres(ip_local_max),kpres(ip_local_max)

CDIR$ NOVECTOR

      DO 10 ip = 1, i_parallel

          tk(ip) = temp(ip) + 273.15

C       k1 and k2 (apparent), from mehrbach

          k1(ip) = 13.7201 - 0.031334 * tk(ip)
     *       - 3235.76 / tk(ip)
     *       - 1.3E-5 * sal(ip) * tk(ip)
     *       + 0.1032 * sal(ip)**(0.5)

          k1(ip) = 10**(k1(ip))
          cp(ip) = (z(ip)/10.) / 83.143 / tk(ip)
          prat(ip) = ( 24.2 - 0.085 * temp(ip) )
     *           * cp(ip)
          prat(ip) = exp(prat(ip))
          k1(ip) = k1(ip) * prat(ip)
           
          k2(ip) = - 5371.9645
     *         - 1.671221 * tk(ip)
     *         + 128375.28 / tk(ip)
     *         + 2194.3055 * LOG( tk(ip) )/2.30259
     *         - 0.22913 * sal(ip)
     *         - 18.3802 * LOG( sal(ip) )/2.30259
     *         + 8.0944E-4 * sal(ip) * tk(ip)
     *         + 5617.11 * LOG( sal(ip) ) / tk(ip) / 2.30259
     *         - 2.136 * sal(ip) / tk(ip)

          k2(ip) = 10**(k2(ip))
          prat(ip) = (16.4 - 0.04*temp(ip))
     *           * cp(ip)
          prat(ip) = exp(prat(ip))
          k2(ip) = k2(ip) * prat(ip)

C    lyman's kb
          kb(ip) = 2291.9/(temp(ip)+273)
     .           + 0.01756 * (temp(ip)+273)
     .           - 3.385
     .           - .32051 * (sal(ip)/1.80655)**(1./3.)
          kb(ip) = 10**(-kb(ip))
          prat(ip) = (27.5 - 0.095*temp(ip))
     *           * cp(ip)
          prat(ip) = exp(prat(ip))
          kb(ip) = kb(ip) * prat(ip)

C    calculate sayles calcite saturation state
         pres(ip) = z(ip)/10
C                bar
         kpres(ip) = LOG(4.75E-7)
c                        kprime
     .             - delv
     .               / (rr * (temp(ip) + 273) ) * (pres(ip))
     .             + 0.5 * dk
     .               / (rr * (temp(ip) + 273) )
     .               * (pres(ip))**2
         kpres(ip) = EXP(kpres(ip))
         csat(ip) = kpres(ip) / 0.01

C    calculate broecker critical carbonate ion
c       csatb = 90*EXP(0.16*(z/1000.-4.))
C    calculate broecker c*
c       csatst = co3 - 18.*(z/1000.-4.)

   10 CONTINUE

      RETURN
      END


      SUBROUTINE calc_buff(alk,tco2,sal,k1,k2,kb,
     .        co2,hco3,co3,
     .        i_parallel)

c             all units of moles/l

      PARAMETER(ip_local_max = 2600)

      REAL alk(i_parallel),tco2(i_parallel),sal(i_parallel)
      REAL k1(i_parallel),k2(i_parallel),kb(i_parallel)
      REAL co2(i_parallel),hco3(i_parallel),co3(i_parallel)

      REAL tbor(ip_local_max),tkt(ip_local_max),tk(ip_local_max)
      REAL c1(ip_local_max),c2(ip_local_max),c4(ip_local_max)
      REAL a(ip_local_max),x(ip_local_max)
      REAL ah1(ip_local_max),aht(ip_local_max)

CDIR$ NOVECTOR

      DO 10 ip = 1, i_parallel
       tbor(ip) = 4.106e-4*sal(ip)/35.

       c1(ip) = k1(ip)/2.0
       c2(ip) = 1.0-4.0*k2(ip)/k1(ip)
       c4(ip) = tbor(ip)*kb(ip)
       aht(ip) = 0.74e-8
 10   CONTINUE

      DO 100 icnt=1,100
      DO 100 ip = 1, i_parallel
        a(ip) = alk(ip)-c4(ip)/(kb(ip)+aht(ip))
        x(ip) = a(ip)/tco2(ip)
        ah1(ip) = c1(ip)/x(ip)
     .          * (1.0-x(ip)+SQRT(
     .                    1.0+c2(ip)*x(ip)*(-2.+x(ip))
     .                           )
     .            )
c        IF(0.5e-4.ge.abs(1.-aht(ip)/ah1(ip))) GOTO 200
        aht(ip)=ah1(ip)
  100 CONTINUE
  200 CONTINUE

      DO 20 ip = 1, i_parallel
      co3(ip) = (a(ip)-tco2(ip))
     .            /(1.0-(ah1(ip)*ah1(ip))/(k1(ip)*k2(ip)))
      hco3(ip) = tco2(ip)/(1.+ah1(ip)/k1(ip)+k2(ip)/ah1(ip))
      co2(ip) = tco2(ip)
     .            /(1.0+k1(ip)/ah1(ip)+k1(ip)*k2(ip)
     .                   /(ah1(ip)*ah1(ip))
     .             )
 20   CONTINUE

      RETURN
      END


       SUBROUTINE o2org(rainorg,rc,kmax,
     *     zsed,delz,form,pore,
     .     dopls,domin,dbpls,dbmin,
     *     o2,zrct,
     *     orgml,orggg,
     *     resp_c,
     .     i_parallel,ip_sedmain_max,nz_sedmain_max,
     *     n_control)

       PARAMETER(epsilon = 1.E-20)

       PARAMETER(ip_o2org_max = 2600)

c    arguments
       REAL rainorg(i_parallel),rc(i_parallel)
       REAL zsed(kmax), delz(kmax)
       REAL form(nz_sedmain_max,ip_sedmain_max)
       REAL pore(nz_sedmain_max,ip_sedmain_max)
       REAL dopls(nz_sedmain_max,ip_sedmain_max)
       REAL domin(nz_sedmain_max,ip_sedmain_max)
       REAL dbpls(nz_sedmain_max,ip_sedmain_max)
       REAL dbmin(nz_sedmain_max,ip_sedmain_max)
       REAL o2(nz_sedmain_max,ip_sedmain_max),zrct(i_parallel)
       REAL orgml(nz_sedmain_max,ip_sedmain_max)
       REAL orggg(nz_sedmain_max,ip_sedmain_max)

c    results
       REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)

c    local variables -- for diagnostics
       REAL rct_c(ip_o2org_max),rms_c(ip_o2org_max)
       REAL rct_o2(ip_o2org_max),rms_o2(ip_o2org_max)

CDIR$ NOVECTOR

       IF(n_control .EQ. 1) THEN
          loop_limit = 25
       ELSE
          loop_limit = 3
       ENDIF

       DO 10 m=1,loop_limit

          CALL orgc(rainorg,rc,zsed,
     .                dbpls,dbmin,pore,zrct,delz,
     .                orggg,orgml,rct_c,rms_c,
     .                kmax,
     .                i_parallel,ip_sedmain_max,nz_sedmain_max)

          CALL o2ss(zsed,delz,orgml,pore,dopls,domin,
     .                 rc,kmax,zrct,
     .                 o2,rct_o2,rms_o2,
     .                 i_parallel,ip_sedmain_max,nz_sedmain_max)

c          WRITE(6,*) 'O2ORG pass # ',m

           DO 20 ip = 1, i_parallel
               zrct(ip) =  MIN( zsed(kmax),
     *                          zrct(ip)
     *                           * o2(1,ip) 
     .                           / ( o2(1,ip) - o2(kmax,ip)
     *                               + epsilon
     *                             )
     *                        )

               IF(zrct(ip) .LT. 0.1) THEN
c                  WRITE (6,*) "low zrct in ip ",ip 
                  zrct(ip) = 0.1
               ENDIF
      
 20        CONTINUE

 10       CONTINUE

       CALL get_resp(rc,orgml,kmax,zrct,zsed,delz,
     .               resp_c,
     .               i_parallel,ip_sedmain_max,nz_sedmain_max)

       RETURN
       END


      SUBROUTINE get_resp(rc,orgml,kmax,zrct,zsed,delz,
     .                    resp_c,
     .                    i_parallel,ip_sedmain_max,nz_sedmain_max)

c   arguments
      REAL rc(i_parallel), orgml(nz_sedmain_max,ip_sedmain_max)
      REAL zrct(i_parallel)
      REAL zsed(kmax), delz(kmax)

c   results
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)

CDIR$ NOVECTOR

      DO 10 i = 1, kmax
      DO 10 ip = 1, i_parallel
          IF(zsed(i).le.zrct(ip)) then
              resp_c(i,1,ip) = rc(ip) * orgml(i,ip)
            ELSEIF(zsed(i-1).le.zrct(ip)) then
              resp_c(i,1,ip) = rc(ip) * orgml(i,ip)
     *                     * (zrct(ip)-zsed(i-1))/delz(i)
            ELSEIF(zsed(i-1).GT.zrct(ip)) then
              resp_c(i,1,ip) = 0.
            ENDIF

          resp_c(i,2,ip) = 0.
          resp_c(i,3,ip) = 0.
   10  CONTINUE

       RETURN
       END
         


      SUBROUTINE orgc(rainorg,rc,zsed,
     .                dbpls,dbmin,pore,zrct,delz,
     .                orggg,orgml,smrct,rmserr,
     .                kmax,
     .                i_parallel,ip_sedmain_max,nz_sedmain_max)

      PARAMETER(ip_orgc_max = 2600)
      PARAMETER(nz_orgc_max = 10)

c   arguments
      REAL rainorg(i_parallel),rc(i_parallel),zrct(i_parallel)
      REAL dbpls(nz_sedmain_max,ip_sedmain_max)
      REAL dbmin(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL zsed(kmax), delz(kmax)

c   results
      REAL orggg(nz_sedmain_max,ip_sedmain_max)
      REAL orgml(nz_sedmain_max,ip_sedmain_max)
      REAL smrct(i_parallel),rmserr(i_parallel)

c   local variables
      REAL res(nz_orgc_max,ip_orgc_max)
      REAL dres(nz_orgc_max,3,ip_orgc_max)
      REAL react(nz_orgc_max,ip_orgc_max)
      REAL dreac(nz_orgc_max,ip_orgc_max)
c   arrays for tridiag
      REAL a(nz_orgc_max,ip_orgc_max)
      REAL b(nz_orgc_max,ip_orgc_max)
      REAL c(nz_orgc_max,ip_orgc_max)
      REAL r(nz_orgc_max,ip_orgc_max)
      REAL u(nz_orgc_max,ip_orgc_max)

CDIR$ NOVECTOR

      DO 1001 ip = 1, i_parallel 
         smrct(ip) = 0.
 1001 CONTINUE

C   ***************************

      DO 6 i=2, kmax
        DO 6 ip = 1, i_parallel
          IF(zsed(i).le.zrct(ip) .AND. orggg(i,ip).GT.0) then
              react(i,ip) = - rc(ip) * orggg(i,ip) * 3.15e7
              dreac(i,ip) = - rc(ip) * 3.15e7
            ELSEif(zsed(i-1).le.zrct(ip)) then
              react(i,ip) = - rc(ip) * orggg(i,ip) * 3.15e7
     *                     * (zrct(ip)-zsed(i-1))/delz(i)
              dreac(i,ip) = - rc(ip) * 3.15e7
     *                     * (zrct(ip)-zsed(i-1))/delz(i)
            ELSEif(zsed(i-1).GT.zrct(ip)) then
              react(i,ip) = 0.
              dreac(i,ip) = 0.
            ENDIF

  6    CONTINUE

C************************

      DO 12 i=3, kmax-1
      DO 12 ip = 1, i_parallel

c       residual(i,ip)
          res(i,ip) = dbpls(i,ip)
     *                * (
     *                      orggg(i+1,ip)
     *                    - orggg(i,ip)
     *                  )
     .             - dbmin(i,ip)
     *                * (
     *                      orggg(i,ip)
     *                    - orggg(i-1,ip)
     *                  )
     .             + react(i,ip)

C        dr/dx(i+1,ip)
           dres(i,1,ip) = dbpls(i,ip)

C        dr/dx(i,ip)
           dres(i,2,ip) = - dbpls(i,ip)
     *                 - dbmin(i,ip)
     .                 + dreac(i,ip)

C           dr/dx(i-1,ip)
          dres(i,3,ip) = dbmin(i,ip)

 12   CONTINUE

C **************************

      DO 1015 ip = 1, i_parallel
      i=2

c       residual(2,ip)
          res(i,ip) = dbpls(i,ip)
     *                * (
     *                      orggg(i+1,ip)
     *                    - orggg(i,ip)
     *                  )
     .             + react(i,ip)
     .             + rainorg(ip) * 12.
     .                 / delz(i)
     .                 / ( 1 - pore(i,ip) )
     .                 / 2.5

C       dr/dx(i+1,ip)
          dres(i,1,ip) = dbpls(i,ip)

C       dr/dx(i,ip)
          dres(i,2,ip) = - dbpls(i,ip)
     .                + dreac(i,ip)

C       dr/dx(i-1,ip) (not defined anyway for i=2)

C********************************

      i = kmax

c       residual(kmax,ip)
          res(i,ip) =
     .             - dbmin(i,ip)
     *                * (
     *                      orggg(i,ip)
     *                    - orggg(i-1,ip)
     *                  )
     .             + react(i,ip)

C       dr/dx(i+1) (not defined anyway)

C       dr/dx(i,ip)
          dres(i,2,ip) = - dbmin(i,ip)
     .                   + dreac(i,ip)

C       dr/dx(i-1,ip)
          dres(i,3,ip) = dbmin(i,ip)

 1015   CONTINUE
C*******************************

c   zero the arrays
c      DO 20 i = 1,kmax
c      DO 20 ip = 1, i_parallel
c        b(i,1,ip) = 0.

c        DO 22 j=1,kmax
c          a(i,j,ip) = 0.
c 22     CONTINUE

 20   CONTINUE

c   set up the residual array
      DO 24 i = 1, kmax-1
      DO 24 ip = 1, i_parallel
c        b(i,1,ip) = - res(i+1,ip)
c       wanted res(2) into b(1), res(3) into b(2) etc.
         r(i,ip) = -res(i+1,ip)
c       want res(2) into r(1), etc
 24   CONTINUE

C   lower off-diagonal, dri/dxi-1
      DO 36 i = 1, kmax-2
      DO 36 ip = 1, i_parallel
c       a(i+1,i,ip) = dres(i+2,3,ip)
c       wanted dres(3,3) in a(2,1), dres(4,3) in a(3,2) etc
        a(i+1,ip) = dres(i+2,3,ip)
c       now want dres(3,3) in a(2), dres(4,3) in a(3), etc
   36 CONTINUE

C   diagonal, dri/dxi
      DO 28 i = 1, kmax-1
      DO 28 ip = 1, i_parallel
c         a(i,i,ip) = dres(i+1,2,ip)
c         wanted dres(2,2) in a(1,1), dres(3,2) in a(2,2) etc
          b(i,ip) = dres(i+1,2,ip)
c         now want dres(2,2) in b(1), dres(3,2) in b(2), etc
 28   CONTINUE

C   upper off-diagonal, dri/dxi+1
      DO 32 i = 1,kmax-2
      DO 32 ip = 1, i_parallel
c         a(i,i+1,ip) = dres(i+1,1,ip)
c         want dres(2,1) in a(1,2), dres(3,1) in a(2,3) etc
          c(i,ip) = dres(i+1,1,ip)
c         now want dres(2,1) in c(1), dres(3,1) in c(2) etc
 32   CONTINUE

c      CALL gaussj(a,b,
c     *            i_parallel,kmax-1,1,
c     *            ip_sedmain_max,
c         3*nz_sedmain_max,1)

      CALL tridiag(a,b,c,r,u,
     *             kmax-1,i_parallel,
     *             ip_orgc_max,nz_orgc_max)

c   update the concentration array
      DO 51 ip = 1, i_parallel
         rmserr(ip) = 0
   51 CONTINUE
      DO 52 i=1,kmax-1
      DO 52 ip = 1, i_parallel
        orggg(i+1,ip) = orggg(i+1,ip) + u(i,ip)
        rmserr(ip) = rmserr(ip) + res(i+1,ip)**2
 52   CONTINUE

      CALL sldcon(orgml,orggg,12.,pore,kmax,
     *            i_parallel,ip_sedmain_max,nz_sedmain_max) 

      DO 56 i=2, kmax
      DO 56 ip = 1, i_parallel

          IF(zsed(i).le.zrct(ip)) then
              react(i,ip) = - rc(ip) * orggg(i,ip)*3.15e7
            ELSEif(zsed(i-1).le.zrct(ip)) then
              react(i,ip) = - rc(ip)
     .                     * orggg(i,ip)*3.15e7/pore(i,ip)
     *                     * (zrct(ip)-zsed(i-1))/delz(i)
            ELSEif(zsed(i-1).GT.zrct(ip)) then
              react(i,ip) = 0.
            ENDIF

          smrct(ip) = smrct(ip) 
     .             + react(i,ip) 
C                      [ g diss / g sl yr ]
     .             * 2.5 
C                      [ g sl / cm3 sl ]
     .             * ( 1 - pore(i,ip) )
C                      [ cm3 sl / cm3 total ]
     .             * delz(i)
C                      [ cm (total) ]
C                      = [ g diss / cm2 yr ]
 56   CONTINUE

C                             into units of moles / cm2 yr
      DO 1016 ip = 1, i_parallel
         smrct(ip) = - smrct(ip) / 12.
 1016 CONTINUE

      DO 112 i=3, kmax-1
      DO 112 ip = 1, i_parallel

c       residual(i)
          res(i,ip) = dbpls(i,ip)
     *                * (
     *                      orggg(i+1,ip)
     *                    - orggg(i,ip)
     *                  )
     .             - dbmin(i,ip)
     *                * (
     *                      orggg(i,ip)
     *                    - orggg(i-1,ip)
     *                  )
     .             + react(i,ip)

 112   CONTINUE

      DO 1112 ip = 1, i_parallel
      i=2
c       residual(2)
          res(i,ip) = dbpls(i,ip)
     *                * (
     *                      orggg(i+1,ip)
     *                    - orggg(i,ip)
     *                  )
     .             + react(i,ip)
     .             + rainorg(ip) * 12.
     .                 / delz(i)
     .                 / ( 1 - pore(i,ip) )
     .                 / 2.5


      i = kmax
c       residual(kmax,ip)
          res(i,ip) =
     .             - dbmin(i,ip)
     *                * (
     *                      orggg(i,ip)
     *                    - orggg(i-1,ip)
     *                  )
     .             + react(i,ip)

 1112 CONTINUE

      DO 59 ip = 1, i_parallel
         rmserr(ip) = 0.
   59 CONTINUE
      DO 60 i=2, kmax
      DO 60 ip = 1, i_parallel
        rmserr(ip) = rmserr(ip) + res(i,ip)**2
        IF(orggg(i,ip).GT.1) orggg(i,ip) = 1.
        IF(orggg(i,ip).LT.0) orggg(i,ip) = 0.
 60   CONTINUE
      DO 1060 ip = 1, i_parallel
         rmserr(ip) = rmserr(ip)**(0.5)
 1060 CONTINUE

      RETURN
      END



       SUBROUTINE o2ss(zsed,delz,orgml,pore,dopls,domin,
     .                 rate,kmax,zrct,
     .                 o2,smrct,rmserr,
     .                 i_parallel,ip_sedmain_max,nz_sedmain_max)

       PARAMETER( ip_o2ss_max = 2600)
       PARAMETER( nz_o2ss_max = 10)

c    arguments
       REAL zsed(kmax), delz(kmax)
       REAL pore(nz_sedmain_max,ip_sedmain_max)
       REAL orgml(nz_sedmain_max,ip_sedmain_max)
       REAL dopls(nz_sedmain_max,ip_sedmain_max)
       REAL domin(nz_sedmain_max,ip_sedmain_max)
       REAL rate(i_parallel), zrct(i_parallel)

c    results
       REAL o2(nz_sedmain_max,ip_sedmain_max)
       REAL smrct(i_parallel),rmserr(i_parallel)

c    internal arrays
       REAL dfplus(nz_o2ss_max,ip_o2ss_max),
     .      dfzero(nz_o2ss_max,ip_o2ss_max),
     .      dfmins(nz_o2ss_max,ip_o2ss_max),
     .      res(nz_o2ss_max,ip_o2ss_max)
c   arrays for tridiag
      REAL a(nz_o2ss_max,ip_o2ss_max)
      REAL b(nz_o2ss_max,ip_o2ss_max)
      REAL c(nz_o2ss_max,ip_o2ss_max)
      REAL r(nz_o2ss_max,ip_o2ss_max)
      REAL u(nz_o2ss_max,ip_o2ss_max)

CDIR$ NOVECTOR

       DO 1 j=2,kmax-1
       DO 1 ip = 1, i_parallel
         res(j,ip) = (   dopls(j,ip)*(o2(j+1,ip)-o2(j,ip))
     *               - domin(j,ip)*(o2(j,ip)-o2(j-1,ip))
     *          ) 
C          units of m / cm2 (total) s
         IF(zsed(j).le.zrct(ip)) then

             res(j,ip) = res(j,ip)
     .                 - 1.3*rate(ip)*orgml(j,ip)/pore(j,ip)

           ELSEif(zsed(j-1).le.zrct(ip)) then

             res(j,ip) = res(j,ip)
     .                 - 1.3*rate(ip)*orgml(j,ip)/pore(j,ip)
     *                   *(zrct(ip)-zsed(j-1))/delz(j)

           ENDIF
C            units of m / cm2 (total) s
         dfplus(j,ip) = dopls(j,ip)
         dfzero(j,ip) = -dopls(j,ip)
     *                  -domin(j,ip)
         dfmins(j,ip) = domin(j,ip)
C          appropriate to units of m / cm2 s
 1     CONTINUE

c       write(6,*) "loop 1"

       DO 1001 ip = 1, i_parallel
       j=kmax

         res(j,ip) = ( - domin(j,ip)*(o2(j,ip)-o2(j-1,ip)) )

         if (zsed(j).LT.zrct(ip)) then

           res(j,ip) = res(j,ip)
     .               - 1.3*rate(ip)*orgml(j,ip)/pore(j,ip)
                     
         ELSEif(zsed(j-1).LT.zrct(ip)) then
           res(j,ip) = res(j,ip) - 1.3*rate(ip)*orgml(j,ip)
     *                  *(zrct(ip)-zsed(j-1))/delz(j)
         ENDIF
         dfplus(j,ip) = 0.
         dfzero(j,ip) = -domin(j,ip)
         dfmins(j,ip) = domin(j,ip)
 1001 CONTINUE

c       write(6,*) "loop 1001"

c       DO 2 j=1,kmax-1
c          DO 2 k=1,kmax-1
c             DO 2 ip = 1, i_parallel
c                a(j,k,ip) = 0.
c 2     CONTINUE

c       write(6,*) "loop 2"

       DO 4 j=1,kmax-2
       DO 4 ip = 1, i_parallel
c         a(j,j+1,ip) = dfplus(j+1,ip)
c         a(j,j,ip) = dfzero(j+1,ip)
c         a(j+1,j,ip) = dfmins(j+2,ip)

          a(j+1,ip) = dfmins(j+2,ip)
c           want dr3/dx2 in a2, dr4/dx3 in a3, etc
          b(j,ip) = dfzero(j+1,ip)
c           want dr2/dx2 in b1, dr3dx3 in b2, etc
          c(j,ip) = dfplus(j+1,ip)
c           want dr2/dx3 in c1, dr3/dx4 in c2, etc
 4     CONTINUE
       DO 1004 ip = 1, i_parallel
c         a(kmax-1,kmax-1,ip) = dfzero(kmax,ip)
c     *                        + dfplus(kmax,ip)
          b(kmax-1,ip) = dfzero(kmax,ip)
     *                 + dfplus(kmax,ip)
 1004  CONTINUE

c       write(6,*) "loop 1004"
       
       DO 5 j=1,kmax-1
       DO 5 ip = 1, i_parallel
c        b(j,1,ip) = - res(j+1,ip)
c         
         r(j,ip) = -res(j+1,ip)
c        want res(2) into r(1), etc
 5     CONTINUE

c       write(6,*) "loop 5"

c       CALL gaussj(a,b,
c     *             i_parallel,kmax-1,1,
c     *             ip_sedmain_max,3*nz_sedmain_max,1)

      CALL tridiag(a,b,c,r,u,
     *             kmax-1,i_parallel,
     *             ip_o2ss_max,nz_o2ss_max)



c       write(6,*) "tridiag"



       DO 1006 ip = 1, i_parallel
          smrct(ip) = 0.
 1006  CONTINUE
       DO 6 j=2,kmax
       DO 6 ip = 1, i_parallel
c         o2(j,ip) = o2(j,ip) + b(j-1,1,ip)
          o2(j,ip) = o2(j,ip) + u(j-1,ip)
         IF(zsed(j).le.zrct(ip)) then
             smrct(ip) = smrct(ip) - 1.3*rate(ip)*orgml(j,ip)
c                              [ moles O2 / l total second ]
     .                       * 3.15e7 / 1000.
c                              [ moles O2 / cm3 yr ]
     .                       * delz(j)
c                              [ moles O2 / cm2 yr ] 
           ELSEif(zsed(j-1).le.zrct(ip)) then
             smrct(ip) = smrct(ip) - 1.3*rate(ip)*orgml(j,ip)
     *                       *(zrct(ip)-zsed(j-1))/delz(j)           
     .                       * 3.15e7 / 1000.
     .                       * delz(j)
           ENDIF
 6     CONTINUE

c       write(6,*) "loop 6"


c    Calculate RMS error
c       DO 1000 ip = 1, i_parallel
c          rmserr(ip) = 0.
c 1000  CONTINUE

c       write(6,*) "loop 1000"

c       DO 100 j = 2, kmax-1
c       DO 100 ip = 1, i_parallel
c         res(j,ip) = ( dopls(j,ip)*(o2(j+1,ip)-o2(j,ip))
c     *               - domin(j,ip)*(o2(j,ip)-o2(j-1,ip))
c     *          ) 
c         IF(zsed(j).le.zrct(ip)) then
c             res(j,ip) = res(j,ip)
c     .               - 1.3*rate(ip)*orgml(j,ip)/pore(j,ip)
c           ELSEif(zsed(j-1).le.zrct(ip)) then
c             res(j,ip) = res(j,ip) - 1.3*rate(ip)*orgml(j,ip)
c     *                   *(zrct(ip)-zsed(j-1))/delz(j)
c           ENDIF
c         rmserr(ip) = rmserr(ip) + res(j,ip)**2
c 100   CONTINUE

c       write(6,*) "loop 100"

c       DO 1007 ip = 1, i_parallel
c       j = kmax
c         res(j,ip) = ( - domin(j,ip)*(o2(j,ip)-o2(j-1,ip)) )
c         IF(zsed(j).LT.zrct(ip)) THEN
c           res(j,ip) = res(j,ip)
c     .             - 1.3*rate(ip)*orgml(j,ip)/pore(j,ip)
c         ELSEIF(zsed(j-1).LT.zrct(ip)) then
c           res(j,ip) = res(j,ip) - 1.3*rate(ip)*orgml(j,ip)
c     *                  *(zrct(ip)-zsed(j-1))/delz(j)
c         ENDIF
c         rmserr(ip) = rmserr(ip) + res(j,ip)**2

c       rmserr(ip) = rmserr(ip)**(0.5)

c 1007  CONTINUE

c       write(6,*) "loop 1007"

       RETURN
       END



      SUBROUTINE calc_do2(difo2,
     *      form,pore,delz,kmax,
     *      dopls,domin,
     .      i_parallel,ip_sedmain_max,nz_sedmain_max)

      REAL difo2
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL dopls(nz_sedmain_max,ip_sedmain_max)
      REAL domin(nz_sedmain_max,ip_sedmain_max)
      REAL delz(kmax)

CDIR$ NOVECTOR

      difo2 = 12.E-6

      DO 30 i = 3,kmax-1
      DO 30 ip = 1, i_parallel
          dopls(i,ip)=difo2
     1             *((form(i+1,ip)+form(i,ip))/2)
     2             * 1 / pore(i,ip)
     3             * 2 / ( (delz(i+1)+delz(i)) * delz(i) )
          domin(i,ip)=difo2
     1             *((form(i-1,ip)+form(i,ip))/2)
     2             * 1/pore(i,ip)
     3             * 2 / ( (delz(i-1)+delz(i)) * delz(i) )
 30   CONTINUE

      DO 1030 ip = 1, i_parallel
        i=kmax
          dopls(i,ip)=0.
          domin(i,ip)=difo2
     1             *((form(i-1,ip)+form(i,ip))/2)
     2             *1/pore(i,ip) 
     3             * 2 / ( (delz(i-1)+delz(i)) * delz(i) )
        i=2
          dopls(i,ip)=difo2
     1             *((form(i+1,ip)+form(i,ip))/2)
     2             *1/pore(i,ip) 
     3             * 2 / ( (delz(i+1)+delz(i)) * delz(i) )
          domin(i,ip)=difo2
     1             *(form(i,ip)+1)/2
     2             *1/pore(i,ip) 
     3             *1/delz(i)**2

 1030 CONTINUE

      RETURN
      END 

       SUBROUTINE calss(raincal,rainorg,rainclay,
     .                  resp_c,cal_c,
     .                  dissc,dissn,csat,u1,u2,
     .                  dcpls,dcmin,
     .                  zsed,delz,form,pore,kmax,
     .                  calml,calgg,carb,
     *                  ttrorg,ttrcal,ttral,ttrtc,difal,diftc,c_advect,
     .                  i_parallel,ip_sedmain_max,
     .                  nz_sedmain_max,
     *                  n_control)

      PARAMETER( ip_calss_max = 2600)

c   arguments
      REAL raincal(i_parallel),rainorg(i_parallel)
      REAL rainclay(i_parallel)
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
      REAL cal_c(nz_sedmain_max,ip_sedmain_max)
      REAL csat(i_parallel),u1(i_parallel),u2(i_parallel)
      REAL dcpls(nz_sedmain_max,3,ip_sedmain_max)
      REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)
      REAL zsed(kmax),delz(kmax)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)

c   results
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL ttrorg(i_parallel),ttrcal(i_parallel),ttral(i_parallel)
      REAL ttrtc(i_parallel),difal(i_parallel),diftc(i_parallel)
      REAL c_advect(i_parallel)

CDIR$ NOVECTOR

c   internal variables
      INTEGER still_wrong(ip_calss_max), sum_wrong

      loop_limit = 60

      DO 150 ip = 1, i_parallel
         still_wrong(ip) = ip
  150 CONTINUE
      sum_wrong = i_parallel

        DO 30 l = 1, 100

         CALL co3ss(resp_c,cal_c,
     .              dissc,dissn,csat,
     *              u1,u2,
     .              zsed,delz,form,pore,kmax,
     .              dcpls,dcmin,
     .              calml,calgg,carb,
     *              ttrorg,ttrcal,ttral,ttrtc,difal,diftc,
     .              i_parallel,ip_sedmain_max,
     .              nz_sedmain_max,loop_limit,
     *              still_wrong,sum_wrong,ip_calss_max)

         DO 1030 ip = 1, i_parallel
           c_advect(ip) = (
     *                    raincal(ip) * 100.
     *                  + rainclay(ip)
     *                  - ttrcal(ip) * 100.
     *                )
c                                       [ g / cm2 yr ]
     .              * calgg(kmax,ip) / 100.
C          moles calcite / cm2 yr buried 
 1030    CONTINUE
  
         sum_wrong = 0

         DO 1040 ip = 1, i_parallel
            IF(
     $           (calgg(kmax,ip) .GT. .001) .AND.
     $           ( raincal(ip) .GT. 1.E-8 )
     $        ) THEN

               IF( 
     .              abs(
     .                   1 - ABS(
     .                            ( ttrcal(ip) + c_advect(ip))
     *                            / raincal(ip)
     .                          )
     .                 ) .GT. 0.001
     .              ) THEN
c                      then the system is out of whack
C                               outputs = inputs to 0.1%
c                               0.05 for quick and dirty runs

                  sum_wrong = sum_wrong + 1
                  still_wrong(sum_wrong) = ip

               ENDIF

            ELSEIF( ttrcal(ip)+c_advect(ip) .LT. raincal(ip) )
     *                 THEN
c                              else it's small but growing
               sum_wrong = sum_wrong + 1
               still_wrong(sum_wrong) = ip
            ENDIF
 1040    CONTINUE

         IF (sum_wrong .LE. 3) THEN
            GO TO 40
c          blow this pop stand
         ELSE
            WRITE(6,*) 'still', sum_wrong,'  wrong in calss'
         ENDIF

         DO 20 k=2,kmax
         DO 20 i_loop = 1, sum_wrong
            i_p = still_wrong(i_loop)
            IF( ( ttrcal(i_p) .LT. 1e-3 ) ) THEN
               calgg(k,i_p) = calgg(kmax,i_p)
     1                     * raincal(i_p) 
     2                     / ( ttrcal(i_p) + c_advect(i_p) )
           ENDIF
C  sometimes get huge initial reaction rates which throw the 
C                                solution into a wierd mode.
C             
C           calcite=calcite * f rain / (reac+advec) 
C             c_advect=(gtotin-greact)*cal(z) 
C            
 20      CONTINUE

         CALL sldcon(calml,calgg,100.,pore,kmax,
     .             i_parallel,ip_sedmain_max,nz_sedmain_max)

c      the overall loop
 30    CONTINUE
 40    CONTINUE

       DO 50 ip = 1, i_parallel
          IF(ttrcal(ip) .GT. raincal(ip)) THEN
             ttrcal(ip) = raincal(ip)
          ENDIF
          c_advect(ip) = raincal(ip) - ttrcal(ip)
   50  CONTINUE

       

       RETURN
       END


       SUBROUTINE co3ss(resp_c,cal_c,
     .                  dissc,dissn,csat,
     *                  u1,u2,
     .                  zsed,delz,form,pore,kmax,
     .                  dcpls,dcmin,
     .                  calml,calgg,carb,
     *                  ttrorg,ttrcal,ttral,ttrtc,difal,diftc,
     .                  i_parallel,ip_sedmain_max,
     .                  nz_sedmain_max,
     *                  loop_limit,
     *                  still_wrong,sum_wrong,ip_calss_max)

      PARAMETER(ip_co3ss_max = 2600)
      PARAMETER(nz_co3ss_max = 10)

c      include 'common.seddebug'

c   arguments
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
      REAL csat(i_parallel),u1(i_parallel),u2(i_parallel)
      REAL zsed(kmax),delz(kmax)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL dcpls(nz_sedmain_max,3,ip_sedmain_max)
      REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)
      INTEGER still_wrong(ip_calss_max),sum_wrong
      

c   results
      REAL cal_c(nz_sedmain_max,ip_sedmain_max)
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)
      REAL ttrorg(i_parallel),ttrcal(i_parallel)
      REAL ttral(i_parallel),ttrtc(i_parallel)
      REAL difal(i_parallel),diftc(i_parallel)

      REAL ttral_o(ip_co3ss_max),ttrtc_o(ip_co3ss_max)
      REAL difal_o(ip_co3ss_max),diftc_o(ip_co3ss_max)
      real ttrcal_o(ip_co3ss_max), ttrorg_o(ip_co3ss_max)
      REAL cal_c_o(nz_co3ss_max,ip_co3ss_max)

c   internals
      INTEGER still_wrong_new(ip_co3ss_max),sum_wrong_new

CDIR$ NOVECTOR

       DO 10 l=1, loop_limit

c          WRITE(7,*) 'going into co3'

         CALL co3(resp_c,
     *                dissc,dissn,csat,
     .                u1,u2,
     .                dcpls,dcmin,
     .                form,pore,kmax,
     .                calml,calgg,carb,cal_c,
     .                i_parallel,ip_sedmain_max,
     .                nz_sedmain_max,
     *                still_wrong,sum_wrong,ip_calss_max)

         CALL diag(ttral,difal,ttrtc,diftc,
     *        ttrcal,ttrorg,
     *        resp_c,cal_c,
     *        carb,pore,delz,
     *        dcmin,
     *        kmax,
     *        i_parallel,ip_sedmain_max,nz_sedmain_max)

c         WRITE(7,*) 'CO3SS pass # ',l

         sum_wrong_new = 0
         DO 30 i_loop = 1, sum_wrong
            ip = still_wrong(i_loop)
c            WRITE(7,*) 'going into loop with ip =',ip
c            IF(
c     *              ( abs(diftc(ip)) + 
c     *                abs(difal(ip)) +
c     *                abs(ttral(ip)) +
c     *                abs(ttrtc(ip))
c     $               ) .GT. 1.E-8 
c     *            ) THEN
               IF( 
     .             ( abs(1 - abs( ttrtc(ip)
     $                           / ( diftc(ip) + 1.E-20 )
     $                          )
     $                 ) .GT. 0.0005
     $              )
     .                  .OR.
     .             ( abs(1 - abs( ttral(ip)
     $                           / ( difal(ip) + 1.E-20 )
     $                          )
     $             ) .GT. 0.0005 .AND. ttral(ip) .NE. 0. )
     .         )  THEN
c                         then it's out of whack
                  sum_wrong_new = sum_wrong_new + 1
                  still_wrong_new(sum_wrong_new) = ip
               ENDIF
c            ENDIF

            IF (ttral(ip) .LT. 0.) THEN
               WRITE(6,*) 'ttral < 0. in pass, ip ',
     $              l, still_wrong(ip)
               CALL reset_pw(carb,csat,
     .               kmax,
     *               still_wrong(ip),
     *               ip_sedmain_max,nz_sedmain_max)
            ENDIF
            IF (carb(kmax,3,ip) .LT. 0.) THEN
               WRITE(6,*) 'co3-- < 0. in pass, ip ',
     $              l, still_wrong(ip)
               CALL reset_pw(carb,csat,
     .               kmax,
     *               still_wrong(ip),
     *               ip_sedmain_max,nz_sedmain_max)
            ENDIF
            IF (carb(kmax,3,ip) .GT. 500.e-6) THEN
               WRITE(6,*) 'co3-- too high in pass, ip ',
     $              l, still_wrong(ip)
               CALL reset_pw(carb,csat,
     .               kmax,
     *               still_wrong(ip),
     *               ip_sedmain_max,nz_sedmain_max)
            ENDIF
               
   30    CONTINUE

c         WRITE(7,*) 'done with loop 30 in co3ss'

         DO 40 i_loop = 1, sum_wrong_new
            still_wrong(i_loop) = still_wrong_new(i_loop)
 40      CONTINUE
         sum_wrong = sum_wrong_new

c         WRITE(7,*) 'loop 40 in co3ss'

         IF( sum_wrong .LE. 1) THEN
            GO TO 20
c         ELSE
c            WRITE(6,*) 'still ', sum_wrong, ' out of whack in co3ss'
         ENDIF

         IF( l .EQ. loop_limit - 20) THEN
            write(6,*) 'reset pw times ', sum_wrong
            DO 50 i_l = 1, sum_wrong
               CALL reset_pw(carb,csat,
     .               kmax,
     *               still_wrong(i_l),
     *               ip_sedmain_max,nz_sedmain_max)
   50       CONTINUE
         ENDIF

   10    CONTINUE
   20    CONTINUE

         WRITE(6,*) 'iterations in co3ss ', l

c         call calc_cal_c(resp_c,
c     *                dissc,dissn,csat,
c     .                u1,u2,
c     .                dcpls,dcmin,
c     .                form,pore,kmax,
c     .                calml,calgg,carb_o,cal_c_o,
c     .                i_parallel,ip_sedmain_max,
c     .                nz_sedmain_max,
c     *                still_wrong,sum_wrong,ip_calss_max)


c         CALL diag(ttral_o,difal_o,ttrtc_o,diftc_o,
c     *        ttrcal_o,ttrorg_o,
c     *        resp_c,cal_c_o,
c     *        carb_o,pore_o,delz,
c     *        dcmin,
c     *        kmax,
c     *        i_parallel,ip_sedmain_max,nz_sedmain_max)

c         do i=1, i_parallel
c            if( ABS( 1 - abs( ttral(i)
c     $           / ( ttral_o(i) + 1.E-20 )
c     $                      )
c     $           ) .GT. 0.01 ) then
c               j = i
c            endif
c         enddo

CDIR$ VECTOR

       RETURN
       END


      SUBROUTINE calc_dc(difc,form,pore,delz,kmax,
     .                  dcpls,dcmin,
     .                  i_parallel,ip_sedmain_max,nz_sedmain_max)
       
      REAL difc(3)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL delz(kmax)
      REAL dcpls(nz_sedmain_max,3,ip_sedmain_max)
      REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)

CDIR$ NOVECTOR

      difc(1) = 10.5e-6
      difc(2) = 6.4e-6
      difc(3) = 5.2e-6 

      DO 30 i=3,kmax-1
        DO 40 j=1,3
        DO 40 ip = 1, i_parallel

          dcpls(i,j,ip)=difc(j)
     1             *(delz(i)*form(i+1,ip)+delz(i+1)*form(i,ip))
     *                / (delz(i)+delz(i+1))
     2             * 1 / pore(i,ip)
     3             *(2/((delz(i+1)+delz(i))*delz(i)))
          dcmin(i,j,ip)=difc(j)
     1             *(delz(i)*form(i-1,ip)+delz(i-1)*form(i,ip))
     *                / (delz(i)+delz(i-1))
     2             * 1 / pore(i,ip)
     3             *(2/((delz(i-1)+delz(i))*delz(i)))
 40     CONTINUE
 30   CONTINUE
      DO 50 j=1,3
      DO 50 ip = 1, i_parallel
        i=kmax
          dcpls(i,j,ip)=0
          dcmin(i,j,ip)=difc(j)
     1             *(delz(i)*form(i-1,ip)+delz(i-1)*form(i,ip))
     *               / (delz(i)+delz(i-1))
     2             * 1 / pore(i,ip)
     3             *(2/((delz(i-1)+delz(i))*delz(i)))
        i=2
          dcpls(i,j,ip)=difc(j)
     1             *(delz(i)*form(i+1,ip)+delz(i+1)*form(i,ip))
     *               / (delz(i)+delz(i+1))
     2             * 1 / pore(i,ip)
     3             *(2/((delz(i+1)+delz(i))*delz(i)))
          dcmin(i,j,ip)=difc(j)
     1             *(form(i,ip)+1)/2
     2             * 1 / pore(i,ip)
     3             *(1/(delz(i)**2))
 50   CONTINUE
      RETURN
      END 


C      file 'diag.for', which calculates the diffusive fluxes of
C        o2, total co2, and alkalinity at the sediment-water
C        interface, and also the integrated reaction rates of
C        those quantities.  used by co3main to determine when to
C        stop repeating the co3 subroutine.

       SUBROUTINE diag(ttral,difal,ttrtc,diftc,
     *        ttrcal,ttrorg,
     *        resp_c,cal_c,
     *        carb,pore,delz,
     *        dcmin,
     *        kmax,
     *        i_parallel,ip_sedmain_max,nz_sedmain_max)

       PARAMETER(ip_local_max = 2600)

c    arguments
       REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
       REAL cal_c(nz_sedmain_max,ip_sedmain_max)
       REAL carb(nz_sedmain_max,3,ip_sedmain_max)
       REAL pore(nz_sedmain_max,ip_sedmain_max),delz(kmax)
       REAL dcmin(nz_sedmain_max,3,ip_sedmain_max)

c    results
       REAL ttral(i_parallel),difal(i_parallel),ttrtc(i_parallel)
       REAL diftc(i_parallel)
       REAL ttrcal(i_parallel),ttrorg(i_parallel)

c    internal arrays
       REAL ttreac(3,ip_local_max), difflx(3,ip_local_max)

CDIR$ NOVECTOR

C    zero the diagnostics variables, ttreac and flux
      DO 10 j=1,3
      DO 10 ip = 1, i_parallel
        ttreac(j,ip) = 0.
        difflx(j,ip) = 0.
        ttrcal(ip) = 0.
        ttrorg(ip) = 0.
 10   CONTINUE

C     reaction rates are in units of mol species/cm2 (total) y
      DO 20 k = 1, kmax
      DO 20 ip = 1, i_parallel

             ttreac(1,ip) = ttreac(1,ip)
     .                   + resp_c(k,1,ip) * delz(k)
     *                     * 3.15E7 / 1e3
             ttreac(2,ip) = ttreac(2,ip)
     .                   + resp_c(k,2,ip) * delz(k)
     *                     * 3.15E7 / 1e3
             ttreac(3,ip) = ttreac(3,ip)
     .                   + resp_c(k,3,ip) * delz(k)
     *                     * 3.15E7 / 1e3
     *                   + cal_c(k,ip) * delz(k)
     *                     * 3.15E7 / 1e3
             ttrcal(ip) = ttrcal(ip)
     .                   + cal_c(k,ip) * delz(k)
     *                     * 3.15E7 / 1e3
             ttrorg(ip) = ttrorg(ip)
     *                   + ( resp_c(k,1,ip)
     *                       + resp_c(k,2,ip)
     *                       + resp_c(k,3,ip)
     *                     ) * delz(k)
     *                     * 3.15e7 / 1e3

 20   CONTINUE

C     the diffusive fluxes

      DO 30 ip = 1, i_parallel

         difflx(1,ip) =   dcmin(2,1,ip)
     1               * ( carb(1,1,ip) - carb(2,1,ip) ) 
     2               * pore(2,ip)
     3               * delz(2)
     4               * 3.15e7 / 1e3
         difflx(2,ip) =   dcmin(2,2,ip)
     1               * ( carb(1,2,ip) - carb(2,2,ip) ) 
     2               * pore(2,ip)
     3               * delz(2)
     4               * 3.15e7 / 1e3
         difflx(3,ip) =   dcmin(2,3,ip)
     1               * ( carb(1,3,ip) - carb(2,3,ip) ) 
     2               * pore(2,ip)
     3               * delz(2)
     4               * 3.15e7 / 1e3

         ttrtc(ip) = ttreac(1,ip) + ttreac(3,ip)
         ttral(ip) = ttreac(3,ip) * 2
         diftc(ip) = difflx(1,ip) + difflx(2,ip) + difflx(3,ip)
         difal(ip) = difflx(2,ip) + difflx(3,ip) * 2.

   30 CONTINUE

       RETURN
       END

      

       SUBROUTINE tridiag(a,b,c,r,u,
     *                    n,i_parallel,
     *                    i_size,n_size)
c        from numerical recipes, page 40, adapted for parallel
       PARAMETER(nmax = 100, ip_local_max = 2600)

c     arguments
       DIMENSION a(n_size,i_size),b(n_size,i_size),c(n_size,i_size)
       DIMENSION r(n_size,i_size),u(n_size,i_size)

c     local variables
       DIMENSION gam(nmax,ip_local_max), bet(ip_local_max)

CDIR$ NOVECTOR

       DO 100 ip = 1, i_parallel
c          IF(b(1,ip).EQ.0.) THEN
c             WRITE(6,*) 'Pause #1, ip = ',ip
c             RETURN
c          ENDIF
          bet(ip) = b(1,ip)
          u(1,ip) = r(1,ip) / bet(ip)
  100  CONTINUE
       DO 11 j = 2, n
       DO 11 ip = 1, i_parallel
          gam(j,ip) = c(j-1,ip) / bet(ip)
          bet(ip) = b(j,ip) - a(j,ip) * gam(j,ip)
c          IF(bet(ip) .EQ. 0.) THEN
c             WRITE(6,*) 'Pause #2, ip = ',ip
c             RETURN
c          ENDIF
          u(j,ip) =(r(j,ip) - a(j,ip) * u(j-1,ip)) / bet(ip)
   11  CONTINUE
       DO 12 j = n-1, 1, -1
       DO 12 ip = 1, i_parallel
          u(j,ip) = u(j,ip) - gam(j+1,ip) * u(j+1,ip)
   12  CONTINUE
       RETURN
       END


      SUBROUTINE calc_db(db,
     .                   pore,zsed,delz,kmax,
     .                   dbpls,dbmin,
     .                   i_parallel,ip_sedmain_max,nz_sedmain_max)

c   external input variables
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL zsed(kmax+1),delz(kmax)

c   results; external variables
      REAL dbpls(nz_sedmain_max,ip_sedmain_max)
      REAL dbmin(nz_sedmain_max,ip_sedmain_max)

CDIR$ NOVECTOR

      db = 0.15

      zsed(kmax+1) = zsed(kmax) + 1.

      DO 10 k=3, kmax-1
      DO 10 ip = 1, i_parallel

            dbpls(k,ip) = db
     1               * 2 / ( (delz(k) + delz(k+1)) * delz(k) )
     2               * ( 1-pore(k,ip)+1-pore(k+1,ip) )/( 1-pore(k,ip) )
            dbmin(k,ip) = db	
     1               * 2 / ( (delz(k) + delz(k-1)) * delz(k) )	
     2               * ( 1-pore(k,ip)+1-pore(k-1,ip) )/( 1-pore(k,ip) )	

 10   CONTINUE	

      DO 20 ip = 1, i_parallel
	k = 2
            dbpls(k,ip) = db	
     1               * 2 / ( (delz(k) + delz(k+1)) * delz(k) )	
     2               * ( 1-pore(k,ip)+1-pore(k+1,ip) )/( 1-pore(k,ip) )	
            dbmin(k,ip) = 0.	
      k = kmax	
            dbpls(k,ip) = 0.	
            dbmin(k,ip) = db	
     1               * 2 / ( (delz(k) + delz(k-1)) * delz(k) )	
     2               * ( 1-pore(k,ip)+1-pore(k-1,ip) )/( 1-pore(k,ip) )	

   20 CONTINUE

      RETURN	
      END	

      SUBROUTINE pore_2_form(pore,form,kmax,expb,	
     .                       i_parallel, ip_sedmain_max,nz_sedmain_max)	
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)	
      DO 10 k = 1, kmax	
      DO 10 ip = 1, i_parallel	
         form(k,ip) = pore(k,ip)**expb	
   10 CONTINUE	
      RETURN	
      END	

      SUBROUTINE sldcon(temp_ml,temp_gg,molwt,pore,kmax,	
     .                  i_parallel,ip_sedmain_max,nz_sedmain_max) 	
C       update the solid concentration accounts
      REAL temp_ml(nz_sedmain_max,ip_sedmain_max)
      REAL temp_gg(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL molwt
      DO 21 k=2,kmax
      DO 21 ip = 1, i_parallel
        temp_ml(k,ip) = temp_gg(k,ip)*2.5*(1-pore(k,ip))*1000/molwt
 21   CONTINUE
      RETURN
      END 


      SUBROUTINE sldfrc(temp_ml,temp_gg,molwt,pore,kmax,
     .                  i_parallel,ip_sedmain_max,nz_sedmain_max) 
C       Update the solid wt. pct. accounts
      REAL temp_gg(nz_sedmain_max,ip_sedmain_max)
      REAL temp_ml(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL molwt
      DO 21 i=2,kmax
      DO 21 ip = 1, i_parallel
        temp_gg(i,ip) = temp_ml(i,ip)*molwt/(2.5*(1-pore(i,ip))*1000)
 21   CONTINUE
      RETURN
      END 


C      routine co3, which calculates a single iteration
C           of the carbonate system chemistry.  must be run 
C           several times because of the non-linearity of 
C           calcite dissolution kinetics.

       SUBROUTINE co3(resp_c,
     *                dissc,dissn,csat,
     .                disoc1,disoc2,
     .                dplus,dminus,
     *                form,pore,kmax,
     .                calml,calgg,carb,cal_c,
     .                i_parallel,ip_sedmain_max,
     .                nz_sedmain_max,
     *                still_wrong,sum_wrong,ip_calss_max)

      PARAMETER(ip_co3_max = 2600)
      PARAMETER(nz_co3_max = 6)
      PARAMETER(lda = 16)

c   arguments
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
      REAL csat(i_parallel),disoc1(i_parallel),disoc2(i_parallel)
      REAL dplus(nz_sedmain_max,3,ip_sedmain_max)
      REAL dminus(nz_sedmain_max,3,ip_sedmain_max)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      INTEGER still_wrong(ip_calss_max),sum_wrong

c   results
      REAL cal_c(nz_sedmain_max,ip_sedmain_max)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)

c   local variables
      REAL r(nz_co3_max,3,ip_co3_max)
      REAL dr(3,3,3,nz_co3_max,ip_co3_max)
      REAL rmstc(ip_co3_max),rmsal(ip_co3_max)
      REAL rmsph(ip_co3_max)
      REAL weight(ip_co3_max)
c      REAL a(3*nz_co3_max,3*nz_co3_max,ip_co3_max)
c      REAL b(3*nz_co3_max,1,ip_co3_max)

c   linpack variables
      REAL bbd(ip_co3_max,3*nz_co3_max)
      INTEGER ipvt(3*nz_co3_max)
      REAL abd(ip_co3_max,lda,3*nz_co3_max)
      REAL abdlin(lda*3*nz_co3_max*ip_co3_max)
      EQUIVALENCE (abd, abdlin)


       DO 7 i = 1,3
       DO 7 i_loop = 1, sum_wrong
         carb(kmax+1, i,still_wrong(i_loop)) =
     *         carb(kmax, i,still_wrong(i_loop))
C          for the bottom boundary condition, no flux
 7     CONTINUE

c       WRITE(6,*) 'first loop'

C    the residual terms: array (depth; tc, alk, ph)

       DO 2 k = 2, kmax
       DO 2 i_loop = 1, sum_wrong
          ip = still_wrong(i_loop)
C      total co2 equation
         r(k-1,1,ip) = (   dplus(k,1,ip) * (carb(k+1,1,ip)-carb(k,1,ip))
     &                 - dminus(k,1,ip) * (carb(k,1,ip)-carb(k-1,1,ip))
     o               )
     &             + (   dplus(k,2,ip) * (carb(k+1,2,ip)-carb(k,2,ip))
     &                 - dminus(k,2,ip) * (carb(k,2,ip)-carb(k-1,2,ip))
     o               )
     &             + (   dplus(k,3,ip) * (carb(k+1,3,ip)-carb(k,3,ip))
     &                 - dminus(k,3,ip) * (carb(k,3,ip)-carb(k-1,3,ip))
     o               )
C                         units of moles / l *porewater* sec
        r(k-1,1,ip) = r(k-1,1,ip) + resp_c(k,1,ip) / pore(k,ip)
     .                        + resp_c(k,2,ip) / pore(k,ip)
     .                        + resp_c(k,3,ip) / pore(k,ip)
C                         units of moles / l *porewater* sec
        IF(carb(k,3,ip).LT.csat(ip)) then
           r(k-1,1,ip) = r(k-1,1,ip) + dissc
     1                *((1-(carb(k,3,ip)/csat(ip)))**dissn) 
     2                *(1-pore(k,ip)) / pore(k,ip)
     3                *calgg(k,ip)
     4                *(2.5*1000)/(100)
           ENDIF

C       alkalinity equation

         r(k-1,2,ip) = dplus(k,3,ip) * (carb(k+1,3,ip)-carb(k,3,ip))
     &          - dminus(k,3,ip) * (carb(k,3,ip)-carb(k-1,3,ip))
     &          + 0.5 * dplus(k,2,ip) * (carb(k+1,2,ip)-carb(k,2,ip))
     &          - 0.5 * dminus(k,2,ip) * (carb(k,2,ip)-carb(k-1,2,ip))
         r(k-1,2,ip) = r(k-1,2,ip) + resp_c(k,3,ip) / pore(k,ip)
     .                   + 0.5 * resp_c(k,2,ip) / pore(k,ip)
         IF(carb(k,3,ip).LT.csat(ip)) then
             r(k-1,2,ip) = r(k-1,2,ip) + dissc
     1              *((1-(carb(k,3,ip)/csat(ip)))**dissn) 
     2              *(1-pore(k,ip)) / pore(k,ip)
     3              *calgg(k,ip)
     4              *(2.5*1000)/(100)
         ENDIF

         r(k-1,3,ip) = carb(k,1,ip) * carb(k,3,ip) / carb(k,2,ip)**2
     &           - disoc2(ip) / disoc1(ip)

 2     CONTINUE
c       WRITE(6,*) 'second loop, label 2'

C    the derivitive terms: array (function, variable, 
C       'k+'= 3 to 'k-' = 1, and depth level k)

       DO 20 k=2,kmax-1
       DO 20 i_loop = 1, sum_wrong
          ip = still_wrong(i_loop)
         dr(1,1,3,k-1,ip) = dplus(k,1,ip)
         dr(1,1,2,k-1,ip) = -dplus(k,1,ip)
     &                 -dminus(k,1,ip)
         dr(1,1,1,k-1,ip) = dminus(k,1,ip)

         dr(1,2,3,k-1,ip) = dplus(k,2,ip)
         dr(1,2,2,k-1,ip) = -dplus(k,2,ip)
     &                 -dminus(k,2,ip)
         dr(1,2,1,k-1,ip) = dminus(k,2,ip)

         dr(1,3,3,k-1,ip) = dplus(k,3,ip)
         dr(1,3,2,k-1,ip) = -dplus(k,3,ip)
     &                 -dminus(k,3,ip)
           IF(carb(k,3,ip).LT.csat(ip)) then
             dr(1,3,2,k-1,ip) = dr(1,3,2,k-1,ip) 
     &                    - dissc * dissn 
     &                      * (1-pore(k,ip)) / pore(k,ip)
     &                      * calgg(k,ip)
     &                      * (2.5*1000)/100
     &                      / csat(ip)
     &                 *((1-(carb(k,3,ip)/csat(ip)))**(dissn-1.)) 
           ENDIF
         dr(1,3,1,k-1,ip) = dminus(k,3,ip)

         dr(2,1,3,k-1,ip) = 0.
         dr(2,1,2,k-1,ip) = 0.
         dr(2,1,1,k-1,ip) = 0.

         dr(2,2,3,k-1,ip) = (0.5) * dplus(k,2,ip)
         dr(2,2,2,k-1,ip) = -(0.5) * dplus(k,2,ip)
     &                    -(0.5) * dminus(k,2,ip)
         dr(2,2,1,k-1,ip) = (0.5) * dminus(k,2,ip)

         dr(2,3,3,k-1,ip) = dplus(k,3,ip)
         dr(2,3,2,k-1,ip) = -dplus(k,3,ip)
     &                    -dminus(k,3,ip)
           IF(carb(k,3,ip).LT.csat(ip)) then
             dr(2,3,2,k-1,ip) = dr(2,3,2,k-1,ip)  
     &                      - dissc * dissn 
     &                      * (1-pore(k,ip)) / pore(k,ip)
     &                      * calgg(k,ip)
     &                      * (2.5*1000)/100
     &                      / csat(ip)
     &                 *((1-(carb(k,3,ip)/csat(ip)))**(dissn-1.)) 
           ENDIF
         dr(2,3,1,k-1,ip) = dminus(k,3,ip)

         dr(3,1,3,k-1,ip) = 0.
         dr(3,1,2,k-1,ip) = carb(k,3,ip) / carb(k,2,ip)**2
         dr(3,1,1,k-1,ip) = 0.

         dr(3,2,3,k-1,ip) = 0.
         dr(3,2,2,k-1,ip) = -(0.5) * carb(k,1,ip) * carb(k,3,ip)
     &                         / carb(k,2,ip)**3
         dr(3,2,1,k-1,ip) = 0.

         dr(3,3,3,k-1,ip) = 0.
         dr(3,3,2,k-1,ip) = carb(k,1,ip) / carb(k,2,ip)**2
         dr(3,3,1,k-1,ip) = 0.

 20    CONTINUE
c       WRITE(6,*) 'third loop, label 20'
C 300     CONTINUE

C    bottom special conditions

       DO 40 l=1,3
C                               function
         DO 40 i=1,3
C                               variable
           DO 40 m=1,3
C                               above, below
             DO 40 i_loop = 1, sum_wrong
                ip = still_wrong(i_loop)
                dr(l,i,m,kmax-1,ip) = dr(l,i,m,kmax-2,ip)
 40    CONTINUE

c       WRITE(6,*) 'loop # 40'

C    load the big array

       DO 13 i = 1, lda*3*nz_co3_max*ip_co3_max
          abdlin(i) = 0.
   13  CONTINUE
c       WRITE(6,*) 'loop # 13'

       DO 50 k=2,kmax
C                               depth level
         DO 50 l=1,3
C                               function
           DO 50 m=1,3
C                               up, down
             DO 50 i=1,3
C                               variable
                 i_row = (k-2)*3
     &                    + l
C                                           row number
                 i_col = (m+k-4)*3
     &              + i
C                                        column number
                 im = 11
                 ib = i_row - i_col + im
                 DO 50 i_loop = 1, sum_wrong
                    ip = still_wrong(i_loop)
                    IF( (i_col .GT. 0.)
     *                       .AND.
     *                  (i_col .LE. (kmax-1)*3)
     *                ) THEN
                       abd(i_loop,ib,i_col)
     *                      = dr(l,i,m,k-1,ip)
                       IF(k.EQ.kmax) then
                          IF(m.EQ.2) THEN
                             abd(i_loop,ib,i_col)
     *                            = abd(i_loop,ib,i_col)
     *                              +dr(l,i,m+1,k-1,ip)
                          ENDIF
                       ENDIF
                    ENDIF
   50            CONTINUE
c       WRITE(6,*) 'loop # 50'

C      load the residual array

       DO 100 k=2,kmax
         DO 100 l=1,3
           DO 100 i_loop = 1, sum_wrong
              ip = still_wrong(i_loop)
              i_row = (k-2)*3+l
              bbd(i_loop,i_row)
     *             = - r(k-1,l,ip)
 100   CONTINUE
c       WRITE(6,*) 'loop # 100'

       CALL my_sgbfa(abd,lda,(kmax-1)*3,5,5,
     *               ipvt,info,sum_wrong,
     *               ip_co3_max,3*nz_co3_max)

       CALL my_sgbsl(abd,lda,(kmax-1)*3,5,5,
     *      ipvt,bbd,sum_wrong,ip_co3_max)

c       WRITE(6,*) 'done with linpack'

       DO 709 i_loop = 1, sum_wrong
          weight(still_wrong(i_loop)) = 1.0
  709  CONTINUE

       IF(sum_wrong .EQ. 1) then
          weight(still_wrong(1)) = 0.5
       ENDIF

       DO 710 k=2,kmax
          DO 710 i_loop = 1, sum_wrong
             ip = still_wrong(i_loop)
             i_row = (k-2)*3+3
             trialw = - 0.75 * carb(k,3,ip)
     *            / bbd( i_loop,i_row )
             IF(  (trialw.GT.0.)
     *               .AND.(
     *            trialw .LT.weight(ip))
     *         )
     *            weight(ip) = trialw
 710     CONTINUE

c       WRITE(6,*) 'set weights'

       DO 600 k=2,kmax
         DO 600 i=1,3
           DO 600 i_loop = 1, sum_wrong
              ip = still_wrong(i_loop)
              i_row = (k-2)*3+i
              carb(k,i,ip)
     *             = carb(k,i,ip)
     *               + bbd(i_loop,i_row)
     *               * weight(ip)
 600   CONTINUE

c       WRITE(6,*) 'adjusted co3 values'


       DO 210 k = 1, kmax
         DO 210 i_loop = 1, sum_wrong
            ip = still_wrong(i_loop)
            IF(carb(k,3,ip).LT.csat(ip)) then
               cal_c(k,ip) = dissc
     1                  *((1-(carb(k,3,ip)/csat(ip)))**dissn) 
     2                  *(1-pore(k,ip))
     3                  *calgg(k,ip)
     4                  *(2.5*1000)/(100)
            ELSE
               cal_c(k,ip) = 0. 
            ENDIF
  210    CONTINUE

c       WRITE(6,*) 'calculated cal_c terms'

       RETURN
       END

      subroutine calc_cal_c(resp_c,
     *                dissc,dissn,csat,
     .                disoc1,disoc2,
     .                dplus,dminus,
     *                form,pore,kmax,
     .                calml,calgg,carb,cal_c,
     .                i_parallel,ip_sedmain_max,
     .                nz_sedmain_max,
     *                still_wrong,sum_wrong,ip_calss_max)

      PARAMETER(ip_co3_max = 2600)
      PARAMETER(nz_co3_max = 6)
      PARAMETER(lda = 16)

c   arguments
      REAL resp_c(nz_sedmain_max,3,ip_sedmain_max)
      REAL csat(i_parallel),disoc1(i_parallel),disoc2(i_parallel)
      REAL dplus(nz_sedmain_max,3,ip_sedmain_max)
      REAL dminus(nz_sedmain_max,3,ip_sedmain_max)
      REAL form(nz_sedmain_max,ip_sedmain_max)
      REAL pore(nz_sedmain_max,ip_sedmain_max)
      REAL calml(nz_sedmain_max,ip_sedmain_max)
      REAL calgg(nz_sedmain_max,ip_sedmain_max)
      INTEGER still_wrong(ip_calss_max),sum_wrong

c   results
      REAL cal_c(nz_sedmain_max,ip_sedmain_max)
      REAL carb(nz_sedmain_max,3,ip_sedmain_max)

c   local variables
      REAL r(nz_co3_max,3,ip_co3_max)
      REAL dr(3,3,3,nz_co3_max,ip_co3_max)
      REAL rmstc(ip_co3_max),rmsal(ip_co3_max)
      REAL rmsph(ip_co3_max)
      REAL weight(ip_co3_max)

       DO 210 k = 1, kmax
         DO 210 ip = 1, i_parallel
            IF(carb(k,3,ip).LT.csat(ip)) then
               cal_c(k,ip) = dissc
     1                  *((1-(carb(k,3,ip)/csat(ip)))**dissn) 
     2                  *(1-pore(k,ip))
     3                  *calgg(k,ip)
     4                  *(2.5*1000)/(100)
            ELSE
               cal_c(k,ip) = 0. 
            ENDIF
  210    CONTINUE

      return
      end


      subroutine my_sgbfa(abd,lda,n,ml,mu,ipvt,info,
     *                    n_matrices,nmat_external_max,ncolmax)

      parameter(nmat_local_max = 2600)

      integer lda,n,ml,mu,ipvt(*),info
      real abd(nmat_external_max,lda,ncolmax)
c
c     modified by archer, Oct 92, for vectorized co3 solution
c     no pivoting.   operates in vector form on entire array of
c     similar matrices.  
c
c     expects abd to be filled continuously to first index = n_matrices
c
c     sgbfa factors a real band matrix by elimination.
c
c     sgbfa is usually called by sgbco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c
c     on entry
c
c        abd     real(lda, n)
c                contains the matrix in band storage.  the columns
c                of the matrix are stored in the columns of  abd  and
c                the diagonals of the matrix are stored in rows
c                ml+1 through 2*ml+mu+1 of  abd .
c                see the comments below for details.
c
c        lda     integer
c                the leading dimension of the array  abd .
c                lda must be .ge. 2*ml + mu + 1 .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c                0 .le. ml .lt. n .
c
c        mu      integer
c                number of diagonals above the main diagonal.
c                0 .le. mu .lt. n .
c                more efficient if  ml .le. mu .
c     on return
c
c        abd     an upper triangular matrix in band storage and
c                the multipliers which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that sgbsl will divide by zero if
c                     called.  use  rcond  in sgbco for a reliable
c                     indication of singularity.
c
c     band storage
c
c           if  a  is a band matrix, the following program segment
c           will set up the input.
c
c                   ml = (band width below the diagonal)
c                   mu = (band width above the diagonal)
c                   m = ml + mu + 1
c                   do 20 j = 1, n
c                      i1 = max0(1, j-mu)
c                      i2 = min0(n, j+ml)
c                      do 10 i = i1, i2
c                         k = i - j + m
c                         abd(k,j) = a(i,j)
c                10    continue
c                20 continue
c
c           this uses rows  ml+1  through  2*ml+mu+1  of  abd .
c           in addition, the first  ml  rows in  abd  are used for
c           elements generated during the triangularization.
c           the total number of rows needed in  abd  is  2*ml+mu+1 .
c           the  ml+mu by ml+mu  upper left triangle and the
c           ml by ml  lower right triangle are not referenced.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sscal,isamax
c     fortran max0,min0
c
c     internal variables
c
      real t(nmat_local_max)
      integer i,isamax,i0,j,ju,jz,j0,j1,k,kp1,l,lm,m,mm,nm1
c
c
      m = ml + mu + 1
      info = 0
c
c     zero initial fill-in columns
c
      j0 = mu + 2
      j1 = min0(n,m) - 1
      if (j1 .lt. j0) go to 30
      do 20 jz = j0, j1
         i0 = m + 1 - jz
         do 10 i = i0, ml
            DO 10 nmat = 1, n_matrices
               abd(nmat,i,jz) = 0.0e0
   10    continue
   20 continue
   30 continue
      jz = j1
      ju = 0
c
c     gaussian elimination with partial pivoting
c
      nm1 = n - 1
      if (nm1 .lt. 1) go to 130
      do 120 k = 1, nm1
         kp1 = k + 1
c
c        zero next fill-in column
c
         jz = jz + 1
         if (jz .gt. n) go to 50
         if (ml .lt. 1) go to 50
            do 40 i = 1, ml
               DO 40 nmat = 1, n_matrices
                  abd(nmat,i,jz) = 0.0e0
   40       continue
   50    continue
c
c        hardwire l = pivot index to no pivoting
c
         lm = min0(ml,n-k)
         l = m
         ipvt(k) = k
c
c        zero pivot implies this column already triangularized
c
c        do test on just one element
c
         if (abd(1,l,k) .eq. 0.0e0) go to 100
c
c           compute multipliers
c
            DO 62 nmat = 1, n_matrices
               IF(abd(nmat,m,k) .EQ. 0.) THEN
                  WRITE(6,*) 'div by ',abd(nmat,m,k),
     *                 ' at 62',nmat,m,k
               ENDIF
               t(nmat) = -1.0e0/abd(nmat,m,k)
   62       CONTINUE

            call my_sscal(lm,t(1),abd(1,m+1,k),
     *           n_matrices,nmat_external_max)
c
c           row elimination with column indexing
c
            ju = min0(max0(ju,mu+ipvt(k)),n)
            mm = m
            if (ju .lt. kp1) go to 90
            do 80 j = kp1, ju
               l = l - 1
               mm = mm - 1
               DO 72 nmat = 1, n_matrices
                  t(nmat) = abd(nmat,l,j)
   72          CONTINUE
               if (l .eq. mm) go to 70
                  DO 74 nmat = 1, n_matrices
                     abd(nmat,l,j) = abd(nmat,mm,j)
                     abd(nmat,mm,j) = t(nmat)
   74             CONTINUE
   70          continue
               call my_saxpy(lm,t(1),abd(1,m+1,k),abd(1,mm+1,j),
     *                    n_matrices,nmat_external_max)
   80       continue
   90       continue
         go to 110
  100    continue
            info = k
  110    continue
  120 continue
  130 continue
      ipvt(n) = n
      if (abd(1,m,n) .eq. 0.0e0) info = n
      return
      end







c Date: Fri, 6 Dec 91 10:50:25 -0500
c From: netlibd@ORNL.GOV (Netlib)
c Subject: Re:send SGBSL from linpack

      subroutine my_sgbsl(abd,lda,n,ml,mu,ipvt,b,
     *                    n_matrices,nmat_external_max)

      parameter(nmat_local_max = 2600)

      integer lda,n,ml,mu,ipvt(*),job
      real abd(nmat_external_max,lda,*),b(nmat_external_max,*)
c
c     sgbsl solves the real band system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by sgbco or sgbfa.
c
c     modified by archer for carbonate solver, Oct 92
c     only job = 0 (solve a*x = b) has been kept
c
c     on entry
c
c        abd     real(lda, n)
c                the output from sgbco or sgbfa.
c
c        lda     integer
c                the leading dimension of the array  abd .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c
c        mu      integer
c                number of diagonals above the main diagonal.
c
c        ipvt    integer(n)
c                the pivot vector from sgbco or sgbfa.
c
c        b       real(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b , where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if sgbco has set rcond .gt. 0.0
c        or sgbfa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call sgbco(abd,lda,n,ml,mu,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call sgbsl(abd,lda,n,ml,mu,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sdot
c     fortran min0
c
c     internal variables
c
      real t(nmat_local_max)
      integer k,kb,l,la,lb,lm,m,nm1
c
      m = mu + ml + 1
      nm1 = n - 1
c
c        job = 0 , solve  a * x = b
c        first solve l*y = b
c
         if (ml .eq. 0) go to 30
         if (nm1 .lt. 1) go to 30
            do 20 k = 1, nm1
               lm = min0(ml,n-k)
               l = ipvt(k)
               DO 22 nmat = 1, n_matrices
                  t(nmat) = b(nmat,l)
   22          CONTINUE
               if (l .eq. k) go to 10
                  DO 24 nmat = 1, n_matrices
                     b(nmat,l) = b(nmat,k)
                     b(nmat,k) = t(nmat)
   24             CONTINUE
   10          continue
               call my_saxpy(lm,t(1),abd(1,m+1,k),b(1,k+1),
     *                       n_matrices,nmat_external_max)
   20       continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            DO 42 nmat = 1, n_matrices
               b(nmat,k) = b(nmat,k)/abd(nmat,m,k)
   42       CONTINUE
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            DO 44 nmat = 1, n_matrices
               t(nmat) = -b(nmat,k)
   44       CONTINUE
            call my_saxpy(lm,t(1),abd(1,la,k),b(1,lb),
     *                    n_matrices,nmat_external_max) 
   40    continue

      return
      end





      subroutine my_sscal(n,sa,sx,n_elements,n_elem_max)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to 1.
c     jack dongarra, linpack, 3/11/78.
c
c     modified by archer, Oct 92, for calcite solver.  
c     for this application, incx = 1 always
      real sa(*),sx(n_elem_max,*)
      integer i,incx,m,mp1,n,nincx,n_elements
c
      if(n.le.0)return
      if(incx.eq.1)return
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,n
         DO 10 nelem = 1, n_elements
            sx(nelem,i) = sa(nelem)*sx(nelem,i)
   10 continue
      return
      end





      subroutine my_saxpy(n,sa,sx,sy,n_matrices,nmat_external_max)
c
c     constant times a vector plus a vector.
c     uses unrolled loop for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
c     modified by archer in Oct 92 for carbonate solver.
c     incx = incy = 1 always.

      real sx(nmat_external_max,*),sy(nmat_external_max,*)
      real sa(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return

      do 10 i = 1,n
         DO 10 nmat = 1, n_matrices
            sy(nmat,i) = sy(nmat,i) + sa(nmat)*sx(nmat,i)
   10 continue

      return
      end


